(function () {
    var that = me.define("comResourceDetail", {
        // 组件可接收的属性参数，如<comDemo cid="myComDemo" value="1"></comDemo>
        data: {
            id: String,
            itemId: String,
        },

        // 组件的初始化方法用ready，ctrl入口方法不可缺少
        ctrl: function () {
        },
        ready: function () {
            that.$scope.isLike = false

            that.getArticleDetail();
            that.addView()
            if (that.$scope.itemId) {
                that.$scope.showLearn = true
                that.listenVideo()
                that.getRoundId()
            }
        },
        //添加阅读量
        addView() {
            Util.ajax({
                data: {},
                url: Util.getApiUrl("/course/resource/addViewCount", {resourceId: that.$scope.id})
            }, function (data) {

            })
        },
        getArticleDetail: function () {
            Util.ajax({
                url: Config.apiPre + "/course/get/resource/" + that.$scope.id
            }, function (data) {
                console.log(data);
                that.resourceLike(data)
                that.$scope.article = {
                    title: data.title,
                    isVideo: data.content.includes('/video/'),
                    content: data.content,
                    dz: data.isRelease === 1,
                    fabulous: data.likeCount === null ? 0 : data.likeCount,
                    readingVolume: data.viewCount === null ? 1 : data.viewCount + 1,
                    img: me.global.getUrl(data.face),
                };
                if (that.$scope.article.isVideo) {
                    that.$scope.article.content = me.global.getUrl2(data.content);
                }
            });
        },
        // 点赞数据处理
        resourceLike: function () {
            Util.ajax({ //对象数据请求
                data: {
                    resourceId: that.$scope.id,
                },
                url: Util.getApiUrl("/course/getList/resourceLike")
            }, function (data) {
                var likeMap = Util.toMap(data, "resourceId"); //data,参数id
                that.$scope.isLike = !!likeMap[that.$scope.id] //数据对象的id
            });
        },
        //点赞与取消
        doLike: function (id) {
            Util.ajax({
                data: {
                    resourceId: id
                },
                url: Util.getApiUrl("/course/resource/like")
            }, function (data) {
                if (that.$scope.isLike) {
                    that.$scope.article.fabulous--
                } else {
                    that.$scope.article.fabulous++
                }
                that.$scope.isLike = !that.$scope.isLike
                if (that.$scope.isLike === true) { //点赞成功移除动画
                    that.$scope.dolike = true
                }
            })
        },
        // 点击开始播放
        play: function () {
            document.querySelector(".main-img").play()
            document.getElementById("poster").style.display = "none";
        },
        //暂停播放
        offs: function () {
            // document.querySelector(".main-img").pause()
            document.getElementById("poster").style.display = "block";
        }, getRoundId() {
            Util.ajax({
                data: {
                    status: 1
                },
                url: Util.getApiUrl("/course/getOne/round")
            }, function (data) {
                that.$scope.roundId = data.id
            })
        }, listenVideo(video) {
            if (video !== undefined) {
                video.addEventListener('ended', function () {
                    that.finishCourseItem()
                }, false);

            } else {
                setTimeout(function () {
                    video = document.querySelector(".main-img")
                    that.listenVideo(video)
                }, 1000)
            }
        }, finishCourseItem() {
            Util.ajax({
                data: {
                    roundId: that.$scope.roundId,
                    itemId: that.$scope.itemId
                }, url: Util.getApiUrl("/course/finishCourseItem")
            }, function () {
                Util.info("学习完成")
            })
        }
    });
})();