(function() {
    var that = me.define("index", {
        ctrl: function() {
            var page = Util.getQueryString("p");
            var isIndex = !page || page == "main/main";

            that.setToken();
            that.getUser(function() {
                that.$scope.isIndex = isIndex;
                me.global.getData(!isIndex, function() {
                    if (!page) {
                        that.switchMenu(1);
                    } else {
                        me.show(page, { showType: 0 });
                    }
                });
            });

            // 检查app更新
            if (Util.isApp() && isIndex) {
                h5Util.checkVersion();
            }

            //监听全屏事件
            that.checkFullScreen();
        },

        getUser: function (callback) {
            Util.ajax({
                url: Util.getApiUrl("/main/getUser")
            }, function (data) {
                me.global("userInfo", data);
                callback();
            });
        },

        checkFullScreen: function() {
            document.addEventListener("webkitfullscreenchange",function() {
                that.$scope.isFullscreen = !that.$scope.isFullscreen;

                if (that.$scope.isFullscreen) {
                    //横屏
                    plus.screen.lockOrientation('landscape-primary');
                } else {
                    //竖屏
                    plus.screen.lockOrientation('portrait-primary');
                }
            });
        },

        setToken: function() {
            var token = localStorage[Config.smokeToken];
            if (token) {
                me.global("token", token);
            } else {
                location.replace("login.html");
            }
        },

        getAccount: function(callback) {
            var accountinfo = localStorage.getItem('accountInfo');
            var token = localStorage.getItem(Config.smokeToken);
            if (!token) {
                location.replace("login.html");
                return;
            }

            if (!that.$scope.isIndex && Util.isApp() && accountinfo) {
                me.global('accountInfo', JSON.parse(accountinfo));
                callback && callback();
            } else {
                Util.ajax({
                    url: Util.getApiUrl("/main/getAccount")
                }, function(data) {
                    localStorage.setItem('accountInfo', JSON.stringify(data))
                    me.global('accountInfo', data)
                    callback && callback()
                });
            }
        },

        showPage: function(page) {
            me.show(page, {
                showType: 0,
                param: {}
            });
        },

        switchMenu: function(index) {
            that.$scope.tab = Number(index);
            switch (Number(index)) {
                //首页
                case 1:
                    me.show("main/main", {
                        showType: 0,
                        param: {}
                    });
                    break;
                case 2:
                    me.show("resource/resource", {
                        showType: 0,
                        param: {}
                    });
                    // that.setAppTitle("","center",[]);
                    break;
                case 3:
                    me.show("ask/ask", {
                        showType: 0,
                        param: {}
                    });
                    // that.setAppTitle("思考","center",[]);
                    break;
                case 4:
                    me.show("tools/tools", {
                        showType: 0,
                        param: {}
                    });
                    // that.setAppTitle("行动","center",[]);
                    break;
                    //我的
                case 5:
                    me.show("my/my", {
                        showType: 0,
                        param: {}
                    });
                    // that.setAppTitle("","center",[]);
                    break;
                default:
                    break;
            }
        },

        setAppTitle: function(title, align, buttons) {
            if (!Util.isApp()) return;

            mui.plusReady(function() {
                var mainWindow = plus.webview.getLaunchWebview();
                mainWindow.setStyle({
                    'titleNView': {
                        'backgroundcolor': '#136bb5',
                        'titletext': "",
                        'titlecolor': '#FFFFFF',
                        'backgroundImage': './img/header-bg.png',
                        'titleAlign': align,
                        'buttons': buttons,
                        // 'default': "transparent"
                    },
                    "scrollIndicator": "none"
                })
            })
        },

        //是否显示底部菜单
        hasNavBottom: function() {
            if (me.page()) {
                return (me.page().src == "home/homeIndex" ||
                    me.page().src == "study/stydyIndex" ||
                    me.page().src == "thinkDo/thinkDoIndex" ||
                    me.page().src == "result/resultIndex" ||
                    me.page().src == "do/doIndex" ||
                    me.page().src == "my/myIndex");
            }

            return false;
        }

    });
})();