var Util = (function($) {
    var that;
    var oldPath = "",
        oldTitle = "",
        oldParam = "";
    var obj = function() {
        this.ajaxCount = 0;
        that = this;
        that.popId = [];

    };

    obj.prototype = {
        getQueryString: function(name) {
            var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i");
            var r = window.location.search.substr(1).match(reg);
            if (r != null) return r[2];
            return "";
        },

        info: function(msg, bl) {
            mui.toast(msg);
        },

        confirm: function(title, content, callback) {
            mui.confirm(content, title, ["取消", "确定"], function(e) {
                if (e.index == 1) {
                    callback();
                }
            });
        },

        popInput: function(title, placeholder, callback) {
            mui.prompt(placeholder, placeholder, title, ["取消", "确定"], function(res) {
                if (res.index == 1) {
                    callback && callback(res.value);
                }
            });
        },

        sum: function(arr) {
            if (arr.length == 0) return 0;

            var sum = 0;
            arr.forEach(a => {
                sum += a;
            });
            return sum;
        },

        selectPop: function(title, data, callback) {
            var id = "my-mui-popover";
            var htmlItem = $("#" + id);
            if (htmlItem.length == 0) {
                var html = `
                    <div id="my-mui-popover" class="mui-popover fixed-center">
                      <ul class="mui-table-view">
                      </ul>
                    </div>`;

                $("body").append(html);

                htmlItem = $("#" + id);
            }

            var ul = htmlItem.find(".mui-table-view");
            ul.empty();
            data.forEach(item => {
                ul.append(`<li class="mui-table-view-cell" data-value="` + item.value + `"><a>` + item.text + `</a></li>`);
            });

            htmlItem.find('.mui-table-view-cell').on("click", function() {
                mui("#" + id).popover('hide');
                var value = $(this).data("value");
                callback(value);
            });

            mui("#" + id).popover('toggle');
        },

        getApiUrl: function(method, param, api) {
            var url;
            if (!method) {
                Util.info("无请求方法");
                return;
            }
            if (method && (method.indexOf("http://") >= 0 || method.indexOf("https://") >= 0))
                url = method;
            else {
                if (!api && !method) return "";

                if (api) {
                    url = api.replace("{method}", method);
                } else {
                    url = Config.apiPre + method;
                }
            }

            if (param) {
                for (var key in param) {
                    if (url.indexOf("?") < 0) url += "?";
                    else url += "&";
                    url += key + "=" + param[key];
                }
            }
            return url;
        },

        ajaxList: function(key, option, callback, noloading, noerror, errorcallback) {
            var serviceName, modelName;
            if (key.indexOf("/") >= 0) {
                serviceName = key.split("/")[0];
                modelName = key.split("/")[1];
            } else {
                serviceName = "main";
                modelName = key;
            }
            option.url = Util.getApiUrl(`/${serviceName}/getList/${modelName}`);
            that.ajax(option, callback, noloading, noerror, errorcallback)
        },

        ajaxGet: function(model, id, callback) {
            var serviceName, modelName;
            if (model.indexOf("/") >= 0) {
                serviceName = model.split("/")[0];
                modelName = model.split("/")[1];
            } else {
                serviceName = "main";
                modelName = model;
            }
            Util.ajax({
                url: Util.getApiUrl("/" + serviceName + "/get/" + modelName + "/" + id)
            }, function(data) {
                callback(data);
            });
        },

        ajaxDel: function(model, ids, callback) {
            var serviceName, modelName;
            if (model.indexOf("/") >= 0) {
                serviceName = model.split("/")[0];
                modelName = model.split("/")[1];
            } else {
                serviceName = "main";
                modelName = model;
            }

            Util.ajax({
                data: {
                    ids: ids
                },
                url: Util.getApiUrl("/" + serviceName + "/del/" + modelName)
            }, callback);
        },

        ajaxSave: function(saveKey, option, callback, noloading, noerror, errorcallback) {
            var serviceName, modelName;
            if (saveKey.indexOf("/") >= 0) {
                serviceName = saveKey.split("/")[0];
                modelName = saveKey.split("/")[1];
            } else {
                serviceName = "main";
                modelName = saveKey;
            }

            option.url = Util.getApiUrl(`/${serviceName}/save/${modelName}`);
            option.data = JSON.stringify(option.data);
            option.headers = { 'content-Type': 'application/json;charset=UTF-8' }
            that.ajax(option, callback, noloading, noerror, errorcallback)
        },

        ajax: function(option, callback, loading, errorCallback, alldata) {
            if (!option.url) {
                Util.info("接口异常");
                return;
            }
            if (option.headers) {
                option.headers.token = me.global.token;
            } else {
                option.headers = {
                    token: me.global.token
                }
            }
            option.data = option.data || {};
            if (option.isJson) {
                option.data = JSON.stringify(option.data);
                option.headers['content-Type'] = 'application/json;charset=UTF-8';
            }

            //标识来自app的请求
            //标识请求来源：1、APP；2、WEB；3、微信；4、客户端；5：WAP
            // if (me.global.isApp)  option.data.source = 3;
            // else if (me.global.isWeixin) option.data.source = 1;
            // else option.data.source = 5;

            // option.data._app_name = Config.APP_NAME;

            if (loading) that.showLoading();
            var startTime = new Date();
            me.ajax(option, function(data) {
                if (loading) that.hideLoading();
                if (alldata) {
                    callback(data);
                    return;
                }

                data = data || {};
                if (me._param.config.debug) {
                    console.group && console.group("ajax");
                    console.log("%c链接", "font-weight:bold");
                    console.log("%c" + option.url + "", "color:red");
                    console.log("%c参数", "font-weight:bold");
                    console.log(JSON.stringify(option.data));
                    console.log("%c返回", "font-weight:bold;");
                    console.log(data.data);
                    console.log("%c执行时间 " + (new Date() - startTime), "font-weight:bold;");
                    console.groupEnd && console.groupEnd();
                }
                if (data.resultCode == 2004) {
                    Util.info("用户名或密码错误");
                    return;
                }
                if ([2008, 2005].indexOf(data.resultCode) >= 0) {
                    Util.info("登录失效，请重新登录");
                    me.global.exit();

                    return;
                }
                if (data.resultCode !== 1) {
                    Util.info(data.resultMsg);
                    return;
                }

                callback && callback(data.data);
            }, function(msg, status) {
                if (loading) that.hideLoading();
                // if (status != 0) Util.info();

                errorCallback && errorCallback();
            });
        },

        fitImg: function(img, parentSelector) {
            img = $(img);

            var src = img.attr("src");
            var parent = parentSelector ? img.parents(parentSelector) : img.parent();
            var parentWidth = parent[0].clientWidth;
            var parentHeight = parent[0].clientHeight;
            var nimg = new Image();
            nimg.onload = function() {
                var imgwidth = this.width;
                var imgheight = this.height;

                img.css("margin-top", "0px");
                if (imgwidth / imgheight > parentWidth / parentHeight) {
                    var rightHeight = parentWidth * imgheight / imgwidth;
                    img.width(parentWidth);
                    img.height(rightHeight);
                    img.css("margin-top", (parentHeight - rightHeight) / 2 + "px");
                } else if (imgwidth / imgheight < parentWidth / parentHeight) {
                    var rightWidth = parentHeight * imgwidth / imgheight;
                    img.width(rightWidth);
                    img.height(parentHeight);
                } else {
                    img.width(parentWidth);
                }
            }
            nimg.src = src;
        },

        /*图片充满容器*/
        fullImg: function(img, parentSelector) {
            img = $(img);

            var src = img.attr("src");
            var parent = parentSelector ? img.parents(parentSelector) : img.parent();
            var parentWidth = parent[0].clientWidth;
            var parentHeight = parent[0].clientHeight;
            var nimg = new Image();
            nimg.onload = function() {
                var imgwidth = this.width;
                var imgheight = this.height;
                img.css({
                    "top": 0,
                    "left": 0
                });
                if (imgwidth / imgheight >= parentWidth / parentHeight) {
                    img.height(parentHeight);
                    var _width = img.width();
                    var _left = (_width - parentWidth) / 2;
                    img.css({ "left": 0 - _left });
                } else {
                    img.width(parentWidth);
                    var _height = img.height();
                    var _top = (_height - parentHeight) / 2;
                    img.css({ "top": 0 - _top });
                }

                img.fadeIn(350);
            }
            nimg.src = src;
        },

        /*
         *   显示loading
         *   @manual:app上默认不显示AppBridge.loading只有特定情况需要
         */
        showLoading: function(manual) {
            this.ajaxCount++;

            if (this.isApp()) {
                var loading = top.document.getElementById("loading");
                if (!loading) {
                    loading = document.createElement("div");
                    loading.id = "loading";
                    top.document.body.appendChild(loading);
                }
                mui.plusReady(function() {
                    plus.nativeUI.showWaiting(null, {
                        modal: true
                    });
                });

            } else {
                var loading = top.document.getElementById("loading");
                if (!loading) {
                    loading = document.createElement("div");
                    loading.id = "loading";
                    loading.innerHTML = "<img src='img/loading.gif' />";
                    top.document.body.appendChild(loading);
                }
            }
        },

        hideLoading: function() {
            this.ajaxCount--;

            if (this.ajaxCount <= 0) {
                if (this.isApp()) {
                    mui.plusReady(function() {
                        plus.nativeUI.closeWaiting();
                    });
                }
                var loading = top.document.getElementById("loading");
                if (loading) {
                    top.document.body.removeChild(loading);
                }
                this.ajaxCount = 0;
            }
        },

        isWeiXin: function() {
            var ua = window.navigator.userAgent.toLowerCase();
            if (ua.match(/MicroMessenger/i) == 'micromessenger') {
                return true;
            } else {
                return false;
            }
        },

        isNum: function(num) {
            return /^\d+(\.\d+)?$/.test(num);
        },

        isIOSApp: function() {
            var f = that.getQueryString('f');
            if (f != 'app') {
                return false;
            }

            var u = navigator.userAgent;
            return !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
        },

        isIOS: function() {
            var u = navigator.userAgent;
            return u.indexOf("iPhone") >= 0 || u.indexOf("iPad") >= 0;
            // return !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
        },

        getDate: function(strDate) {
            if (!strDate) return;

            var u = navigator.userAgent;
            var flag = u.indexOf("iPhone") >= 0 || u.indexOf("iPad") >= 0 || u.indexOf("Safari") >= 0;

            if (flag) {
                strDate = strDate.replace(/\-/g, "/");
            }
            return new Date(strDate);
        },

        toMax: function() {
            var gui = require('nw.gui');
            var win = gui.Window.get();
            win.maximize();
        },

        clearCache: function() {
            require("nw.gui").App.clearCache();
        },

        /*
         *   对象数组根据key值转化为map
         *   @arr：待转化的数组
         *   @idField：转化依据的对象字段
         *   @idField2：转化依据的扩展字段
         *   @char：扩展字段连接字符
         */
        toMap: function(arr, idField, idField2, char) {
            if (!arr) return {};

            var map = {};
            arr.forEach(function(item) {
                var field = item[idField];
                if (idField2) {
                    field += char + item[idField2];
                }
                map[field] = item;
            });
            return map;
        },

        //从Notice提取关键字段：case_id/report_id
        resolveNotice: function(content, acceptor) {
            var reg = /<notice.*?type="(.*?)".*?>.*?<\/notice>/ig;
            var match = reg.exec(content);
            var replacer = [];
            while (match) {
                var template = match[0],
                    type = match[1];

                switch (type) {
                    case "case":
                        var r = /<notice.*?field="(.*?)".*?value="(.*?)".*?>(.*?)<\/notice>/ig;
                        var m = r.exec(template);
                        var obj = {
                            field: m[1],
                            value: m[2],
                            content: m[3]
                        };
                        acceptor.case_id = obj.value;
                        break;

                    case "report":
                        var r = /<notice.*?reportid="(.*?)".*?caseid="(.*?)".*?>(.*?)<\/notice>/ig;
                        var m = r.exec(template);
                        var obj = {
                            reportid: m[1],
                            caseid: m[2],
                            content: m[3]
                        };
                        acceptor.report_id = obj.reportid;
                        acceptor.case_id = obj.caseid;
                        break;
                }
            }
        },

        toGroup: function(arr, idField) {
            if (!arr) return [];

            var group = {};
            arr.forEach(function(item) {
                group[item[idField]] = group[item[idField]] || { field: item[idField] };
                group[item[idField]].list = group[item[idField]].list || [];
                group[item[idField]].list.push(item);
            });
            return group;
        },

        isPhone: function(phone) {
            var reg = /^[1][0-9]{10}$/;
            return reg.test(phone);
        },

        isPrice: function(price) {
            var reg = /(^[1-9]\d*(\.\d{1,2})?$)|(^0(\.\d{1,2})?$)/;
            return reg.test(price);
        },

        isMail: function(mail) {
            var reg = /^(\w)+(\.\w+)*@(\w)+((\.\w+)+)$/;
            return reg.test(mail);
        },

        //身份证验证
        idnumber: function(str) {
            var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
            return reg.test(str);
        },

        showAddCount: function(el) {
            var pos = el.getBoundingClientRect();
            var div = document.createElement("div");
            div.innerHTML = "+1";
            div.className = "countpp";
            div.style.cssText = "left:" + pos.left + "px;top:" + pos.top + "px;";
            document.body.appendChild(div);

            div.addEventListener("webkitAnimationEnd", function() {
                $(div).remove();
            })
        },

        log: function(message) {
            return;
            var logDiv = document.getElementById("logDiv");
            if (!logDiv) {
                logDiv = document.createElement("div");
                logDiv.id = "logDiv";
                logDiv.style.cssText = `
                    font-size:12px;
                    position:fixed;
                    bottom:50px;
                    left:0;
                    width:100%;
                    color:white;
                    background-color:rgba(0,0,0,0.6);
                    line-height:20px;
                `;
                document.body.appendChild(logDiv);
            }

            logDiv.innerHTML += message + "<br/>";
        },

        /*
         *   打开页面
         *   @path：页面地址
         *   @title：页面标题
         *   @param：参数
         *   @callback：回调函数
         *   @pageCallback：页面回调函数
         */
        showPage: function(page, title, param, callback, isFullPage) {
            if (this.isApp()) {

                var _id = new Date().getTime();
                var pageSrc = "index.html?p=" + page + "&myid=" + _id;
                if (param) {
                    for (var p in param) {
                        pageSrc += "&" + p + "=" + param[p];
                    }
                }

                var pageName = pageSrc.substring(0, 30);
                if (page.indexOf("http") == 0 || isFullPage) {
                    pageSrc = page;
                    pageName = "outPage" + Math.random().toString().substring(10);
                    isFullPage = true;
                }

                var w = plus.webview.create(pageSrc, pageName, {
                    'titleNView': {
                        'backgroundImage': 'linear-gradient(to right, #ED392F, #FC8965)',
                        'titletext': title,
                        'titlecolor': '#FFFFFF',
                        'autoBackButton': true
                    }
                });
                plus.webview.show(w, "pop-in", 300);
                w.addEventListener('close', function() {
                    var paramStr = localStorage.getItem(_id);
                    var param = paramStr ? JSON.parse(paramStr).param : null;
                    if (paramStr) {
                        localStorage.removeItem(_id);
                    }

                    callback && callback(param);

                    w = null;
                });
            } else if (this.isWeiXin()) {
                if (ConfigWxPage[page]) { //用html页面
                    return me.show(page, {
                        showType: 1,
                        param: param
                    }).on('hide', callback);
                } else { // html页面
                    var _id = new Date().getTime();
                    var pageSrc = location.protocol + "//" + location.host + "/app/?p=" + page + "&myid=" + _id;
                    if (param) {
                        for (var p in param) {
                            pageSrc += "&" + p + "=" + param[p];
                        }
                    }

                    wx.miniProgram.navigateTo({
                        url: "/pages/index/index?src=" + encodeURIComponent(pageSrc),
                        events: {
                            acceptDataFromOpenedPage: function(data) {
                                callback && callback(data);
                            }
                        }
                    });
                }
            } else {
                //获取页面配置
                if (page.indexOf("http://") >= 0 || page.indexOf("https://") >= 0) {
                    location.href = Util.getApiUrl(page, param);
                    return;
                }

                return me.show(page, {
                    showType: 1,
                    param: param
                }).on('hide', callback);
            }
        },

        updatePage: function(page, title, param, callback) {
            if (this.isApp()) {
                var _id = new Date().getTime();
                var pageSrc = "index.html?p=" + page + "&myid=" + _id;
                if (param) {
                    for (var p in param) {
                        pageSrc += "&" + p + "=" + param[p];
                    }
                }

                location.replace(pageSrc);
                this.setAppTitle(title, "center");

            } else {
                me.hide();

                setTimeout(() => {
                    me.show(page, {
                        showType: 1,
                        param: param
                    }).on('hide', callback);
                }, 200);
            }
        },

        hidePage: function(param) {
            if (this.isApp()) {
                if (param) {
                    var myid = that.getQueryString('myid');
                    localStorage[myid] = JSON.stringify({
                        param: param
                    });
                }

                var ws = plus.webview.currentWebview();
                plus.webview.close(ws);

            } else if (this.isWeiXin()) {
                if (ConfigWxPage[me.page().src] && me._param.pageList.length > 1) { //用html页面
                    me.hide(param);
                } else {
                    wx.miniProgram.postMessage({ data: param });
                    wx.miniProgram.navigateBack();
                }
            } else {
                me.hide(param);
            }
        },

        /*获取cookievalue*/
        getCookieValue: function(a) {
            var b = a + "=";
            var c = document.cookie.indexOf(b);
            if (c != -1) {
                c += b.length;
                var d = document.cookie.indexOf(";", c);
                if (d == -1) {
                    d = document.cookie.length;
                }
                return unescape(document.cookie.substring(c, d));
            } else {
                return "";
            }
        },

        //判断设备
        checkDevice: function() {
            if (/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)) { //判断iPhone|iPad|iPod|iOS
                return "Ios";
            } else if (/(Android)/i.test(navigator.userAgent)) { //判断Android
                return "Android"
            } else {
                return "PC"
            };
        },

        preventDefault: function(e) {
            var e = e || window.event;
            //如果提供了事件对象，则这是一个非IE浏览器
            if (e && e.stopPropagation)
                //因此它支持W3C的stopPropagation()方法
                e.stopPropagation();
            else
                //否则，我们需要使用IE的方式来取消事件冒泡
                window.event.cancelBubble = true;

            //如果提供了事件对象，则这是一个非IE浏览器
            if (e && e.preventDefault)
                //阻止默认浏览器动作(W3C)
                e.preventDefault();
            else
                //IE中阻止函数器默认动作的方式
                window.event.returnValue = false;
            return false;
        },

        //选择图片
        uploadFile: function(callback, isMulti, maxNumber) {
            var _callback = callback;
            var img = {};
            if (Util.isWeiXin()) {
                wx.chooseImage({
                    count: isMulti ? (maxNumber || 9) : 1, // 默认9
                    sizeType: ['compressed'], // 可以指定是原图还是压缩图，默认二者都有
                    sourceType: ['album', 'camera'], // 可以指定来源是相册还是相机，默认二者都有
                    success: function(res) {
                        Util.showLoading();
                        var localIds = res.localIds;
                        var finishCount = 0;
                        var serverIds = [];
                        localIds.forEach(localId => {
                            wx.uploadImage({
                                localId: localId, // 需要上传的图片的本地ID，由 chooseImage 接口获得
                                isShowProgressTips: 0, // 默认为1，显示进度提示
                                success: function(res) {
                                    serverIds.push(res.serverId);

                                    if (serverIds.length == localIds.length) {
                                        //调用接口下载
                                        Util.ajax({
                                            data: {
                                                mediaIds: serverIds.join(",")
                                            },
                                            url: Util.getApiUrl("/weixin/uploadMedia")
                                        }, function(data) {
                                            data.forEach(filePath => {
                                                callback({
                                                    filePath: filePath
                                                });
                                            });
                                            Util.hideLoading();
                                        });
                                    }
                                }
                            });
                        });
                    }
                });
            } else if (me.global.isApp) {
                plus.gallery.pick(function(e) {
                    // 上传图片
                    h5Util.uploadFile(e.files, function(data) {
                        data.forEach(item => {
                            callback({
                                filePath: item.data[0].filePath
                            });
                            me.control().$scope.$apply();
                        });

                    }, {
                        token: me.global.token
                    });
                }, function(e) {
                    console.log("取消选择图片");
                }, {
                    filter: "image",
                    maximum: 8,
                    multiple: true,
                    permissionAlert: true,

                });
            } else {
                me.global.uploadFile({ fileType: 0 }, "image/png,image/jpeg,image/jpg", null, function(data) {
                    if (!data) return;
                    _callback && _callback(data);
                    me.control().$scope.$apply();
                });
            }

        },

        //格式化提示输出
        formatNotice: function(content) {
            var reg = /<notice.*?type="(.*?)".*?>.*?<\/notice>/ig;
            var match = reg.exec(content);
            var replacer = [];
            while (match) {
                var template = match[0],
                    type = match[1];

                switch (type) {
                    case "case":
                        var r = /<notice.*?field="(.*?)".*?value="(.*?)".*?>(.*?)<\/notice>/ig;
                        var m = r.exec(template);
                        var obj = {
                            field: m[1],
                            value: m[2],
                            content: m[3]
                        };
                        replacer.push([template, "<a onclick='me.global.viewCase(" + obj.value +
                            ");me.ngobj.$scope.$apply();'>" + obj.content + "</a> "
                        ]);
                        break;

                    case "font":
                        var r = /<notice.*?color="(.*?)".*?>(.*?)<\/notice>/ig;
                        var m = r.exec(template);
                        var obj = {
                            color: m[1],
                            content: m[2]
                        };
                        replacer.push([template, "<font style='color:" + obj.color + ";'>" + obj.content + "</font>"]);
                        break;

                    case "report":
                        var r = /<notice.*?reportid="(.*?)".*?caseid="(.*?)".*?>(.*?)<\/notice>/ig;
                        var m = r.exec(template);
                        var obj = {
                            reportid: m[1],
                            caseid: m[2],
                            content: m[3]
                        };
                        replacer.push([template, "<a onclick='me.global.viewReport(" + obj.caseid +
                            "," + obj.reportid + ");me.ngobj.$scope.$apply();'>" + obj.content + "</a> "
                        ]);
                        break;
                }

                match = reg.exec(content);
            }

            for (var i = 0; i < replacer.length; i++) {
                content = content.replace(replacer[i][0], replacer[i][1])
            }

            return content;
        },

        GetNoticeId: function(content) {
            return /<notice.*?field="(.*?)".*?value="(.*?)".*?>(.*?)<\/notice>/ig.exec(content)[2];
        },

        extend: function(a, b) {
            if (!b) return;
            for (var key in b) {
                a[key] = b[key];
            }
        },

        merge: function(a, b) {
            b.forEach(item => {
                a.push(item);
            });
        },

        checkData: function(pageClassName, model) {
            var itemList = $("." + pageClassName + " .myform-label.require");
            for (var i = 0; i < itemList.length; i++) {
                var label = itemList.eq(i);
                var text = label.text().replace("：", "");
                var field = label.attr("field");

                if (field) {
                    var fieldList = field.split(',');
                    for (var j in fieldList) {
                        if (!model[fieldList[j]]) {
                            Util.info("缺少" + text);
                            return false;
                        }
                    }
                } else {
                    var item = label.parent();

                    field = item.find("[ng-model]").attr("ng-model");
                    if (!field) continue;

                    field = field.split(".")[1]

                    if (!model[field]) {
                        Util.info("缺少" + text);
                        return false;
                    }
                }
            }

            return true;
        },

        sendMsg: function(data, callback) {
            Util.ajax({
                data: data,
                url: Util.getApiUrl("/main/save/message"),
                isJson: true
            }, callback);
        },

        isApp: function() {
            if (this.isWeiXin()) return false;

            if (/Android|webOS|iPad|iPhone|iPod|BlackBerry/i.test(navigator.userAgent)) {
                return true;
            }
            return false;
        },

        setAppTitleNone: function() {
            if (!this.isApp()) return;
            if (!window.plusready) {
                setTimeout(function() {
                    Util.setAppTitleNone();
                }, 10);
                return;
            }

            var mainWindow = plus.webview.currentWebview();
            mainWindow.setStyle({
                'titleNView': false
            })
        },

        setAppTitle: function(title, align, buttons) {
            if (!this.isApp()) return;

            if (!window.plusready) {
                setTimeout(function() {
                    Util.setAppTitle(title, align, buttons);
                }, 10);
                return;
            }
 
            var mainWindow = plus.webview.currentWebview();
            mainWindow.setStyle({
                'titleNView': {
                    'backgroundImage': 'linear-gradient(to right, #ED392F, #FC8965)',
                    'titletext': title,
                    'titlecolor': '#FFFFFF',
                    // 'backgroundImage': './img/header-bg.png',
                    'titleAlign': align,
                    'buttons': buttons,
                    'type': "default"
                },
                // "scrollIndicator": "none"
            })
        },

        setAppTitleBtn: function(buttons) {
            if (!this.isApp()) return;

            mui.plusReady(function() {
                var mainWindow = plus.webview.currentWebview();
                mainWindow.setStyle({
                    'titleNView': {
                        'buttons': buttons,
                    }
                })
            });
        },

        cleanHtml: function(s) {
            if (!s) return "";

            var r = /<.*?>/g;
            return s.replace(r, "");
        },

        getPdfHtml: function(html) {
            //img以</img>结尾
            var r = /<img(.*?)>/g;
            return html.replace(r, function(rs, $1) {
                return '<img' + $1 + '></img>';
            });
        },

        getMinute: function(second) {
            var m = Math.floor(second / 60);
            var s = second - m * 60;
            var s_str = (100 + s).toString().substring(1);
            var m_str = (100 + m).toString().substring(1);
            return m_str + ":" + s_str;
        },

        changeOssImgSize: function(url, width) {
            if (!url.indexOf("aliyuncs") < 0) return url;

            if (url.toLowerCase().indexOf(".jpeg") > 0 ||
                url.toLowerCase().indexOf(".jpg") > 0 ||
                url.toLowerCase().indexOf(".png") > 0 ||
                url.toLowerCase().indexOf(".bmp") > 0 ||
                url.toLowerCase().indexOf(".gif") > 0) {
                if (url.indexOf("?") < 0) url += "?";
                else url += "&";

                if (!width) width = 600;
                url += "x-oss-process=image/resize,w_" + width + ",m_lfit";
            }

            return url;
        },

        tryGetJson: function(str) {
            try {
                return JSON.parse(str);
            } catch (e) {
                return str;
            }
        },

        checkObjExists: function(objName) {
            var names = objName.split('.');
            var o = window;
            for (var i in names) {
                var n = names[i];
                o = o[n];

                if (!o) return false;
            }

            return !!o;
        },

        waitObj: function(objPath, callback, times) {
            if (!times) times = 1;

            if (times > 10) {
                console.log("return");
                callback(false);
                return;
            }

            if (!this.checkObjExists(objPath)) {
                setTimeout(function() {
                    Util.waitObj(objPath, callback, times + 1);
                }, 100);
                return;
            }

            callback(true);
        },

        getAny: function(obj) {
            if (!obj) return;

            for (var key in obj) {
                return {
                    key: key,
                    value: obj[key]
                };
            }
        },

        formatParam: function(param, likeFields, dateFields) {
            for (var field in param) {
                // like查询
                if (likeFields && likeFields.indexOf(field) >= 0 && param[field]) {
                    param[field] += ':';
                }
            }

            // 日期范围
            if (dateFields) {
                for (let i = 0; i < dateFields.length; i++) {
                    const item = dateFields[i];
                    var date1 = item[1],
                        date2 = item[2],
                        searchName = item[0];

                    if (param[date1] && param[date2]) {
                        param[searchName] = param[date1] + '~' + param[date2];
                        delete param[date1];
                        delete param[date2];
                    } else if (param[date1]) {
                        param[searchName] = param[date1] + '~';
                        delete param[date1];
                    }
                }
            }
        },

        replaceBr: function(obj, fields) {
            fields.forEach(f => {
                if (!obj[f]) return;

                var text = obj[f];
                text = text.split("\n").join("</div><div>");
                text = "<div>" + text + "</div>"
                obj[f] = text;
            });
        },

        setCourseFinish: function(courseId, callback) {
            if (!courseId) {
                callback && callback();
                return;
            }

            Util.ajax({
                data: {
                    courseId: courseId
                },
                url: Util.getApiUrl("/course/setCourseFinish")
            }, callback);
        },

        // refreshData: function(scope,name,fn) {
        //     if (!this.isWeiXin()) return;

        //     setTimeout(function() {
        //         var data = scope[name];
        //         fn(function() {
        //             var newData = scope[name];

        //             if (newData.length == data.length) {
        //                 Util.refreshData();
        //             }
        //         });
        //     },5000);
        // },

        callInQueue: async function(fnArr, callback) {
            if (fnArr == null || fnArr.length == 0) return;


        },

        promise: function() {

        }

    };

    return new obj();
})(jQuery);