var delayCall = (function(){
    var cacheName = "courseUploadData";

    var fn = function(){};

    fn.prototype = {    
        /* 
         * 获取缓存数据
         * @param id cacheId
         * @return 缓存项
         */
        get: function(id){
            return getCacheData();
        },

        /* 
         * 添加到待提交队列
         * @param path 接口路径
         * @param param 提交参数
         */
        push: function(path,param){
            var cacheData = getCacheData(),
                cacheId = getCacheId();

            cacheData.push({
                cacheId: cacheId,
                path: path,
                param: param
            });

            setCacheData(cacheData);

            return cacheId;
        },

        /* 
         * 从队列中移除
         * @param cacheId 缓存id
         */
        remove: function(cacheId){
            var cacheData = getCacheData();

            for(var i in cacheData) {
                if (cacheData[i].cacheId == cacheId) {
                    cacheData.splice(i, 1);
                    break;
                }
            }

            setCacheData(cacheData);
        },

        /*
         * 递归提交到服务器
         * @param cacheData 缓存的数据
         */
        submit: function(cacheData){
            if (!cacheData)
                cacheData = getCacheData();

            if (cacheData.length == 0) return;

            var item = cacheData.shift();
            var that = this;
            Util.ajax({
                data: item.param,
                url: Util.getApiUrl(item.path)
            },function(){
                setCacheData(cacheData);
                that.submit(cacheData);
            });
        }
    };

    /* 
     * 获取缓存集合
     */
    function getCacheData() {
        var cacheData = [];
        if (localStorage[cacheName]) {
            cacheData = JSON.parse(localStorage[cacheName]);
        }

        return cacheData;
    }

    /* 
     * 设置缓存集合
     * @param cacheData 缓存集合
     */
    function setCacheData(cacheData) {
        localStorage[cacheName] = JSON.stringify(cacheData);
    }

    /* 
     * 生成随机缓存id
     */
    function getCacheId() {
        return new Date().getTime();
    }


    return new fn();
})();