var h5Util = (function(){
    var isUpgrading = false;

    var fn = function(){
        
    }
    
    fn.prototype = {
        getIsUpgrading: function(){
            return isUpgrading;
        },

        uploadFile: function(pathList,callback,headers,rlt){
            if (!rlt) rlt = [];
            
            if (!pathList || pathList.length == 0) {
                callback && callback(rlt);
                return;
            }
            
            var that = this;
            var path = pathList.shift();
            var task = plus.uploader.createUpload( 
                Util.getApiUrl("/file/upload/uploadFile"), 
                { method:"POST" },
                function ( t, status ) {
                    // 上传完成
                    if ( status == 200 ) { 
                        var data = JSON.parse(t.responseText);
                        rlt.push(data);
                    }
                    
                    that.uploadFile(pathList,callback,headers,rlt);
                }
            );
            if (headers) {
                for(var name in headers) {
                    task.setRequestHeader(name, headers[name]);
                }
            }
            
            task.addFile( path, {key:"upload_file"} );
            task.start();
        },
        
        /*
         * 检查app版本
         * @param callback 如果不需要更新则回调
         */
        checkVersion: function(callback){
            var that = this;
            mui.plusReady(function () {
                plus.runtime.getProperty(plus.runtime.appid, function(widgetInfo) {
                    var localVersion = widgetInfo.versionCode;
                    Util.ajax({
                        url: Util.getApiUrl("/main/getVersion")
                    },function(data){
                        var serverVersion = data.versionCode;
                        
                        if (localVersion != serverVersion) {
                            Util.info("发现新版本，正在更新...");
                            that.upgrade(data.downloadUrl);
                            return;
                        } else {
                            that.checkFirstRun();
                        }
                        
                        callback && callback();
                    });
                });
            });
        },

        checkFirstRun: function(){
            if (!Util.isIOS()) return;

            // 检查是否第一次打开app
            plus.io.requestFileSystem(plus.io.PRIVATE_WWW,function(fs){
                fs.root.getFile("index.js",{create: false},function(entry){
                    
                },function(error){
                    plus.runtime.install("_www/app.wgt", {
                        force:true//忽略版本校验，强制更新
                    }, function() {
                        plus.runtime.restart();
                    }, function(e) {
                    });
                });
            });
        },

        getVersion: function(callback){
            mui.plusReady(function () {
                plus.runtime.getProperty(plus.runtime.appid, function(widgetInfo) {
                    var localVersion = widgetInfo.version,
                        code = widgetInfo.versionCode;
                    callback(localVersion+"_"+code);
                });
            });
        },
        
        upgrade: function(resDownloadUrl){
            isUpgrading = true;
            var dtask=plus.downloader.createDownload(resDownloadUrl, {}, function(d, status) {
                if(status == 200) {
                    plus.runtime.install(d.filename, {
                        force:true//忽略版本校验，强制更新
                    }, function() {
                        // plus.nativeUI.closeWaiting();//关闭消息提示
                        // console.log("安装更新文件成功！");
                        
                        Util.info("更新成功，3秒后自动重启应用...");
                        setTimeout(function(){
                            plus.runtime.restart();
                        },3000);
                    }, function(e) {
                       
                    });
                } else {
                    // TODO 下载失败
                }
            });
            dtask.start(); 
        },
        
        /*
         * 切换全屏
         * @param type 1:退出全屏 2:进入全屏
         */
        toggleScreen: function(type){
            if (Util.checkDevice() == "Android") {

            } else {
                if (type == 1) { // 竖屏
                    plus.screen.lockOrientation('portrait');
                } else { // 横屏
                    plus.screen.lockOrientation('landscape');
                }
            }
        },

        createSearch: function(callback){
            mui.plusReady(function () {
                var currentWebview = plus.webview.currentWebview();
                var nTitle = currentWebview.getTitleNView();  
                nTitle.draw(  
                    [
                        {  
                            "tag": "rect",  
                            "id": "rect",  
                            "color": "#999",  
                            "position": {  
                                "left": "50px",  
                                "right": "10%",  
                                "top": "7px",  
                                "bottom": "7px"  
                            },  
                            "rectStyles": {  
                                "color": "#f6f6f6",  
                                "radius": "30px",  
                                "borderColor": "#999"  
                            }  
                        },  
                        {  
                            "tag": "font",  
                            "id": "font",  
                            'text':'\ue904',
                                
                            "position": {  
                                "left": "55px",  
                                "width": "30px",  
                                "top": "7px",  
                                "bottom": "7px"  
                            },  
                            "textStyles": {  
                                "size": "13px",  
                                "fontSrc": "/fonts/bar-icon.ttf",  
                                "color": "#999"  
                            }  
                        },  
                        {  
                            "tag": "input",  
                            "id": "input",  
                            "position": {  
                                "left": "60px",  
                                "right": "10%",  
                                "top": "7px",  
                                "bottom": "7px"
                            },  
                            "inputStyles": {  
                                "placeholder": "请输入搜索关键字",  
                                "borderRadius": "30px",  
                                "borderWidth": "0px", 
                                "borderColor": '#f6f6f6',
                                "fontSize": "13px",  
                                "type": "text",  
                                "color": "#999",  
                                onComplete: function(e) {  
                                    callback(e.text);
                                    
                                    // console.log('点击搜索执行' + e.text)  
                                },  
                                onFocus: function(e) {  
                                    // 获得焦点
                                },  
                                onBlur: function(e) {  
                                    //失去焦点
                                    // console.log("失去焦点")
                                }  
                            }  
                        },  
                        {  
                            "tag": "font",  
                            "id": "searchText",  
                            'text':'搜索',
                            "position": {  
                                "left": "90%",
                                "right": "0px",  
                                "top": "7px",  
                                "bottom": "7px"  
                            },  
                            "textStyles": {  
                                "size": "13px",  
                                "color": "#fff",
                                "align": "center"
                            }  
                        },  
                        {  
                            "tag": "richtext",  
                            "id": "searchBtn",  
                            'text':'',
                            "position": {  
                                "left": "90%",
                                "right": "0px",  
                                "top": "7px",  
                                "bottom": "7px"  
                            },  
                            "richTextStyles": {  
                                onClick:function(e) {
                                    var input = nTitle.getInputValueById("input");
                                    callback(input);
                                }
                            }  
                        }
                    ]  
                ); 
            });
                
        },

        drawLogo: function(logoSrc,callback){
            if (!Util.isApp()) return;

            mui.plusReady(function () {
                var currentWebview = plus.webview.currentWebview();
                var nTitle = currentWebview.getTitleNView();  
                if (!nTitle) return;
                nTitle.draw(  
                    [{  
                        "tag": "img",  
                        "id": "img",  
                        "color": "#999",  
                        "position": {  
                            "left": "10px",  
                            "top": "7px", 
                            "height": "28px",
                            "width": "135px"
                        },  
                        "src": logoSrc
                    }]  
                ); 
            });
        }
    };
    
    return new fn();
})();