me.ready(function() {
    me.global({
        //字符串格式
        timeGMTToString: function(str, format) {
            if (!str) return;
            str = str.split(' ');
            var date_str = str[0];
            var time_str = "";
            if (str.length > 1)
                time_str = str[1];
            date_str = date_str.split('-');
            time_str = time_str.split(':');
            var date = new Date();
            date.setFullYear(date_str[0], date_str[1] - 1, date_str[2]);
            date.setHours(time_str[0], time_str.length > 1 ? time_str[1] : 0, time_str.length > 2 ? time_str[2] : 0, time_str.length > 3 ? time_str[3] : 0);
            return me.global.dateToString(date, format);
        },
        //日期格式
        timespanToString: function(timespan, format) {
            if (!timespan) return "";

            if (Util.isIOS() && typeof(timespan) == "string") {
                timespan = timespan.replace(/\-/g, "/");
            }
            var date = new Date(timespan);
            var o = {
                "M+": date.getMonth() + 1, //month
                "d+": date.getDate(), //day
                "h+": date.getHours(), //hour
                "m+": date.getMinutes(), //minute
                "s+": date.getSeconds(), //second
                "q+": Math.floor((date.getMonth() + 3) / 3), //quarter
                "S": date.getMilliseconds() //millisecond
            }
            if (/(y+)/.test(format))
                format = format.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));

            for (var k in o) {
                if (new RegExp("(" + k + ")").test(format)) {
                    format = format.replace(RegExp.$1,
                        RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
                }
            }

            return format;
        },

        dateToString: function(date, format) {
            var o = {
                "M+": date.getMonth() + 1, //month
                "d+": date.getDate(), //day
                "h+": date.getHours(), //hour
                "m+": date.getMinutes(), //minute
                "s+": date.getSeconds(), //second
                "q+": Math.floor((date.getMonth() + 3) / 3), //quarter
                "S": date.getMilliseconds() //millisecond
            }
            if (/(y+)/.test(format))
                format = format.replace(RegExp.$1, (date.getFullYear() + "").substr(4 - RegExp.$1.length));

            for (var k in o) {
                if (new RegExp("(" + k + ")").test(format)) {
                    format = format.replace(RegExp.$1,
                        RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
                }
            }

            return format;
        },

        generateMbx: function(scope, pageTitle) {
            var from = me.param() ? me.param().from : null;
            if (!from) return;

            if (typeof from == "string") {
                from = [from];
            }

            from.push(pageTitle);

            scope.fromList = from;
        },

        showPop: function(elId, intervals) {
            $('#' + elId).modal('show');
            $('#' + elId).on('hidden.bs.modal', function(e) {
                if (intervals) {
                    me.utils.each(intervals, function(interval) {
                        clearInterval(interval);
                    })
                };
                me.hide();
            });
        },

        hidePop: function(elId, data) {
            /*取消showPop时绑定的默认hide事件*/
            $('#' + elId).unbind("hidden.bs.modal");
            $('#' + elId).on('hidden.bs.modal', function(e) {
                me.hide(data);
            });

            $('#' + elId).modal('hide');
        },

        isShowMenu: function(roleId) {
            if (!me.global.user) {
                return;
            }

            for (var i = 0; i < roleId.length; i++) {
                if (roleId[i] == me.global.user.RoleId) {
                    return true;
                }
            }

            return false;
        },

        myshow: function(page, options) {
            return me.show(page, options);
        },

        ellipsisStr: function(str, length) {
            if (!str) return;

            if (str.length > length) {
                return str.substr(0, length) + "...";
            }
            return str;
        },

        replaceLink: function(str) {
            if (!str) return "";
            return str.replace(/<[^>]*>/g, "").replace(/&nbsp;/g, "");
        },

        getTime: function(strtime) {
            var minute = 60 * 1000; // 1分钟
            var hour = 60 * minute; // 1小时
            var day = 24 * hour; // 1天
            var month = 31 * day; // 月
            var year = 12 * month; // 年

            var date;
            if (/^\d+$/.test(strtime)) {
                strtime = parseInt(strtime + "000");
                date = new Date(strtime);
            } else {
                strtime = strtime.split(' ');
                var date_str = strtime[0];
                var time_str = "";
                if (strtime.length > 1)
                    time_str = strtime[1];
                date_str = date_str.split('-');
                time_str = time_str.split(':');
                date = new Date();
                date.setFullYear(date_str[0], date_str[1] - 1, date_str[2]);
                date.setHours(time_str[0], time_str.length > 1 ? time_str[1] : 0, time_str.length > 2 ? time_str[2] : 0, time_str.length > 3 ? time_str[3] : 0);
            }
            var diff = new Date() - date;

            if (diff > year) {
                r = Math.floor(diff / year);
                return r + "年前";
            }
            if (diff > month) {
                r = Math.floor(diff / month);
                return r + "月前";
            }
            if (diff > day) {
                r = Math.floor(diff / day);
                return r + "天前";
            }
            if (diff > hour) {
                r = Math.floor(diff / hour);
                return r + "小时前";
            }
            if (diff > minute) {
                r = Math.floor(diff / minute);
                return r + "分钟前";
            }
            return "刚刚";
        },

        getDate: function(str) {
            if (!str) return;
            str = str.split(' ');
            var date_str = str[0];
            var time_str = "";
            if (str.length > 1)
                time_str = str[1];
            date_str = date_str.split('-');
            time_str = time_str.split(':');
            var date = new Date();
            date.setFullYear(date_str[0], date_str[1] - 1, date_str[2]);
            date.setHours(time_str[0], time_str.length > 1 ? time_str[1] : 0, time_str.length > 2 ? time_str[2] : 0, time_str.length > 3 ? time_str[3] : 0);

            var minute = date.getMinutes();
            var hour = date.getHours();
            var day = date.getDate();
            var month = date.getMonth() + 1;
            var year = date.getFullYear();
            var now = new Date();
            var now_day = now.getDate();
            var now_month = now.getMonth() + 1;
            var now_year = now.getFullYear();
            if (year == now_year && month == now_month && day == now_day) {
                return "今天 " + (hour < 10 ? ("0" + hour) : hour) + ":" + (minute < 10 ? ("0" + minute) : minute)
            } else {
                return year + "/" + (month < 10 ? ("0" + month) : month) + "/" + (day < 10 ? ("0" + day) : day)
            }
        },
        //将秒转成分
        getTimes: function(z) {
            let m = Math.floor(z / 60);
            let s = z % 60;
            m = m < 10 ? "0" + m : m;
            s = s < 10 ? "0" + s : s;
            return `${m}:${s}`
        },
        //数字格式化
        formartCount: function(count) {
            var res = 0;
            if (count > 1000000000) {
                res = Math.floor(count / 100000000) + '亿'
            } else if (count > 100000) {
                res = Math.floor(count / 10000) + '万';
            } else {
                res = count
            }
            return res
        },

        //pc上传图片
        uploadFile: function(data, accept, size, callback, progressCallback, multi, beginUpload) {
            MyFile.upload({
                multi: multi == undefined ? true : multi,
                url: Util.getApiUrl("/file/upload/uploadFile"),
                param: data,
                accept: accept, //"image/jpeg,image/png",
                before: function(files) {
                    size = size || 1024 * 1024 * 40; // 默认40M限制
                    if (files[0].size > size) {
                        Util.info("文件大小不能超过" + (size / 1024 / 1024) + "MB");
                        return false;
                    }

                    if (beginUpload) beginUpload(files);
                    Util.showLoading();
                },
                after: function(data) {
                    Util.hideLoading();
                    data = JSON.parse(data).data;
                    callback && callback(Array.isArray(data) ? data[0] : data);
                },
                error: function() {
                    Util.hideLoading();
                    Util.info("上传失败");
                },
                progress: function(value) {
                    if (progressCallback) progressCallback(value);
                }
            });
        },

        /*点击显示大图
         * cursrc当前点击图片链接
         * srcs  图片链接数组
         * memo  图片备注数组
         * isDelete 是否可删除
         * callback 可删除时回调 回调data为数组
         */
        showImageView: function(cursrc, srcs, memo, isDelete, callback, refresh) {
            event.stopPropagation();
            srcs = me.copy(srcs);
            var currentIndex = srcs.indexOf(cursrc);
            cursrc = me.global.getUrl2(cursrc);
            var len = srcs.length;
            for (var i = 0; i < len; i++) {
                srcs[i] = me.global.getUrl2(srcs[i]);
            }

            if (Util.isWeiXin()) {
                wx.previewImage({
                    current: cursrc, // 当前显示图片的http链接
                    urls: srcs, // 需要预览的图片http链接列表
                    fail: function(err) {
                        Util.info(JSON.stringify(err));
                    }
                });
            } else if (Util.isApp()) {
                plus.nativeUI.previewImage(srcs, {
                    current: currentIndex,
                    indicator: "number",
                    onLongPress: function(event) {
                        plus.nativeUI.actionSheet({
                            title: "选择操作",
                            cancel: "取消",
                            buttons: [{ title: "下载图片" }]
                        }, function(e) {
                            var index = e.index;
                            if (index == 1) {
                                var dtask = plus.downloader.createDownload(srcs[event.index], {}, function(file, status) {
                                    if (status == 200) {
                                        plus.gallery.save(file.getFileName(), function() {
                                            Util.info("下载成功");
                                        }, function() {
                                            Util.info("下载失败，请稍后再试！")
                                        });
                                        // plus.runtime.openFile(file.getFileName(),{},function() {});

                                    } else {
                                        Util.info("下载失败，请稍后再试！")
                                    }
                                });
                                Util.info("开始下载");
                                dtask.start();
                            }
                        });
                    }
                });
            } else {
                return;
                me.show("common/imgview", {
                    showType: 1,
                    style: "pop",
                    param: {
                        list: srcs,
                        cur: cursrc,
                        memoList: memo,
                        index: srcs.indexOf(cursrc),
                        isDelete: isDelete
                    }
                }).on("hide", function(data) {
                    //$(".fr-window,.fr-overlay").remove();
                    if (!isDelete) return;
                    callback && callback(data);
                })

                if (refresh) me.ngobj.$scope.$apply();
            }
        },

        delImgList: function(list, index) {
            event.stopPropagation();
            list.splice(index, 1);
        },

        showKeywordLink: function(item_id, type, title) {
            switch (type) {
                case 1:
                    Util.showPage("anti", title, {
                        id: item_id
                    });
                    me.ngobj.$scope.$apply();
                    break;
                case 2:
                    Util.showPage("disease", title, {
                        id: item_id
                    });
                    me.ngobj.$scope.$apply();
                    break;
            }
        },
        //手机设备信息
        getDevice: function(deviceType) {
            switch (deviceType) {
                case 0:
                    return "";
                case 1:
                    return "来自iPhone";
                case 2:
                    return "来自Android";
                default:
                    return "";
            }
        },

        //获取枚举数据
        getData: function(readCache, callback) {
            var cacheData = localStorage.getItem("enumdata");
            if (readCache && cacheData) {
                cacheData = JSON.parse(cacheData);
                me.global('enumData', cacheData.enumData);
                me.global('enumMap', cacheData.enumMap);

                callback && callback();
                return;
            }
            Util.ajax({
                method: "POST",
                data: {},
                url: Util.getApiUrl(`/main/getCodeList`)
            }, function(data) {
                var enumData = {},
                    enumMap = {};
                for (var enumname in data) {
                    enumData[enumname] = [];
                    enumMap[enumname] = {};

                    for (var code in data[enumname]) {
                        enumData[enumname].push({
                            code: code,
                            text: data[enumname][code]
                        });

                        enumMap[enumname][code] = {
                            text: data[enumname][code]
                        }
                    }

                }
                me.global('enumData', enumData);
                me.global('enumMap', enumMap);

                // 存储缓存
                var cacheData = {
                    enumData: enumData,
                    enumMap: enumMap
                };
                localStorage['enumdata'] = JSON.stringify(cacheData);

                callback && callback();
            })
        },

        /*图片缓存*/
        noCacheUrl: function(url) {
            if (!url)
                return;
            if (url.indexOf("?") >= 0)
                url += "&r=" + (new Date().getTime() + "");
            else
                url += "?r=" + (new Date().getTime() + "");
            return url;
        },

        hidePage: function(param) {
            Util.hidePage(param);
        },

        _hidePage: function(param) {
            Util.preventDefault();
            me.hide(param);
        },

        //回到顶部
        goTop: function() {
            $(".go-top").bind("click", function(event) {
                $('html,body').animate({ scrollTop: '0px' }, 800);
                event.stopPropagation();
            });
            $(document).scroll(function() {
                if (window.scrollY > window.screen.height - 200) {
                    $(".go-top").css({ display: "block" });
                } else {
                    $(".go-top").css({ display: "none" });
                }
            });
        },

        bindGoTop: function() {
            $(".goTop").bind("click", function(event) {
                $('html,body').animate({ scrollTop: '0px' }, 0);
                event.stopPropagation();
            });
        },

        //打开设置页面
        set: function() {
            var f = Util.getQueryString('f');
            Util.showPage("common/set", "设置", {}, function(data) {
                if (!data) return;
            })
        },

        goLogin: function() {
            Util.showPage("login", "登录", {}, function(data) {});
        },

        //去除html标签,获取内容
        htmlFormat: function(msg) {
            var a = msg.replace(/<\/?.+?>/g, "");
            return a.replace(/ /g, "");
        },

        getFace: function(urls, defaultUrl) {
            if (!urls) {

                if (defaultUrl) {
                    return defaultUrl;
                }

                return;
            }

            return me.global.getUrl(urls.split(",")[0]);
        },

        getUrl: function(url, baseUrl, defaultUrl, width) {
            if (!url) {
                if (defaultUrl) {
                    return defaultUrl;
                }

                return '';
            }
            if (url.indexOf("http://") >= 0 || url.indexOf("https://") >= 0) {
                url = Util.changeOssImgSize(url, width);
                return url;
            }

            if (url.indexOf("/") != 0) {
                url = "/" + url;
            }

            var rlt = (baseUrl || me.global.res) + url;
            rlt = Util.changeOssImgSize(rlt, width);
            return rlt;
        },

        getUrl2: function(url) {
            if (!url) return;

            if (url.indexOf("/") != 0) {
                url = "/" + url;
            }
            return me.global.res + url;
        },

        exit: function() {
            //清空缓存数据
            // localStorage.clear();
            if (me.global.isApp) {
                mui.plusReady(function() {
                    var ws = plus.webview.all();

                    for (var i = ws.length - 1; i > 0; i--) {
                        var item = ws[i];

                        plus.webview.close(item);
                    }
                    ws[0].loadURL("login.html");
                    ws[0].setStyle({
                        'titleNView': {
                            'backgroundcolor': '#136bb5',
                            'titletext': " ",
                            'titlecolor': '#FFFFFF',
                            'backgroundImage': '',
                            'titleAlign': "center",
                            'buttons': [],
                            // 'buttons':[],
                            // 'type': "float"
                        }
                    });
                });
            } else if (Util.isWeiXin()) {
                wx.ready(function() {
                    wx.miniProgram.reLaunch({
                        url: "/pages/login/login",
                        success: function() {

                        },
                        fail: function(e) {

                        }
                    });
                });

            } else {
                location.replace("login.html");
            }
        },

        //清空app推送数量显示
        clearLogoBadge: function() {
            if (!me.global.isApp) return;
            // AppBridge.setLogoBadge({
            //     type: 1,
            //     num: 0
            // });
        },

        trimNum: function(num, count) {
            if (!num) return;

            if (!count || count == 0) return Math.round(num);

            return parseFloat(num.toFixed(count).replace(/\.?0+$/, ''));
        },

        round: function(num) {
            return Math.round(num);
        },

        percent: function(num1, num2) {
            num1 = num1 || 0;
            if (num1 > num2) return 100;
            return Math.min(Math.round(num1 / num2 * 100) || 0, 100);
        },

        splitSecond: function(second) {
            if (!second) return "00:00";

            var hour = Math.floor(second / 3600);
            var hour_str = (100 + hour).toString().substring(1);
            var muit = Math.floor((second - hour * 3600) / 60);
            var muit_str = (100 + muit).toString().substring(1);
            var sec = second - hour * 3600 - muit * 60;
            var sec_str = (100 + sec).toString().substring(1);

            return (hour_str != '00' ? hour_str + ":" : '') + muit_str + ":" + sec_str;
        },

        cleanHtml: function(s) {
            return Util.cleanHtml(s);
        },

        getLetter: function(index) {
            return String.fromCharCode(65 + index);
        },

        getNum: function(num) {
            let changeNum = ['零', '一', '二', '三', '四', '五', '六', '七', '八', '九']; //changeNum[0] = "零"
            let unit = ["", "十", "百", "千", "万"];
            num = parseInt(num);
            let getWan = (temp) => {
                let strArr = temp.toString().split("").reverse();
                let newNum = "";
                for (var i = 0; i < strArr.length; i++) {
                    newNum = (i == 0 && strArr[i] == 0 ? "" : (i > 0 && strArr[i] == 0 && strArr[i - 1] == 0 ? "" : changeNum[strArr[i]] + (strArr[i] == 0 ? unit[0] : unit[i]))) + newNum;
                }
                return newNum;
            }
            let overWan = Math.floor(num / 10000);
            let noWan = num % 10000;
            if (noWan.toString().length < 4) noWan = "0" + noWan;
            return overWan ? getWan(overWan) + "万" + getWan(noWan) : getWan(num);
        },

        getTimeStatus: function(date1, date2) {
            if (!date1 || !date2) return;

            date2 = date2.replace("00:00:00", "23:59:59");
            var now = new Date();
            var d1 = Util.getDate(date1);
            var d2 = Util.getDate(date2);

            if (d1 > now) {
                return "未开始";
            } else if (d1 <= now && now <= d2) {
                return "进行中";
            } else {
                return "已结束";
            }
        },

        addImgList: function(list) {
            Util.uploadFile(function(res) {
                if (!res) return;

                if (res instanceof Array) {
                    Util.merge(list, res);
                } else {
                    list.push(res.filePath);
                    me.ngobj.$scope.$apply();
                }
            }, true, 4);
        },

        clickRenovationItem: function(d) {
            me.getCom("myRenovation", function(com) {
                com.clickItem(d);
            });
        },

        toPage: function(path, title, param) {
            Util.showPage(path, title, param);
        },

        reverseNumber: function(model, key) {
            model[key] = model[key] ? 0 : 1;
        },

        getAge: function(birthday) {
            if (!birthday) return;

            var date = Util.getDate(birthday).getFullYear(),
                now = new Date().getFullYear();

            return now - date;
        }

    });

    me.global("res", Config.res);
    me.global("isWeixin", Util.isWeiXin());
    me.global("isApp", Util.isApp());

    me.global("imagePre", Config.res);
    me.global("token", localStorage.getItem(Config.smokeToken));
});