(function ($) {
    var that = me.define("login", {
        ctrl: function () {
            that.$scope.is_show_del_icon = false;
            that.$scope.tab = 1;
            that.$scope.param = {};
            that.$scope.type = 1;

            that.$scope.smscode = null;

            // 检查app更新
            if (Util.isApp()) {
                h5Util.checkVersion();
            }

            that.getSetting();
        },

        changeType: function () {
            that.$scope.type = that.$scope.type === 1 ? 0 : 1;
        },

        changeTab: function (tab) {
            that.$scope.errMsg = null;
            that.$scope.is_send_phone = false;
            if (tab == 1) {
                that.$scope.tab = 2;

                that.changeImgUrl();
            } else {
                that.$scope.tab = 1;
            }
        },

        getSetting: function () {
            Util.ajax({
                url: Util.getApiUrl("/main/getOne/setting")
            }, function (data) {
                that.$scope.setting = data || {};
            });
        },

        LoginError: function (msg) {
            if (that.timer_info) {
                clearTimeout(that.timer_info);
                that.timer_info = null;
            }

            that.$scope.errMsg = msg
            that.timer_info = setTimeout(function () {
                that.$scope.errMsg = null
                that.$scope.$apply()
            }, 3000);
        },

        login: function (model) {
            // if (!model.isAgree) {
            //     Util.info("未同意服务协议和隐私政策");
            //     return;
            // }

            var path = '';
            if (that.$scope.type == 1) {
                if (!model.loginid) {
                    Util.info('请输入用户名！')
                    return
                }
                if (!model.password) {
                    Util.info('请输入密码！')
                    return
                }

                path = '/auth/login';
            } else {
                model.code = that.getInputCode();
                if (!model.phone) {
                    Util.info('请输入手机号！')
                    return
                }
                // if (!model.code) {
                //     Util.info('请输入验证码！')
                //     return
                // }

                path = '/main/loginUser';
            }
            Util.ajax({
                data: model,
                url: Config.apiPre + path
            }, function (data) {
                localStorage.setItem(Config.smokeToken, data.token)
                if(data.roleId==3) { // 医生
                    location.href = "doctor.html";
                } else { //用户
                    location.href = "index.html";
                }
            });
        },

        getInputCode: function () {
            var code = '';
            for (var i = 1; i <= 4; i++) {
                code += $("#loginCode" + i).val();
            }
            return code;
        },

        nextTip: function () {
            var param = that.$scope.param;
            if (!param.isAgree) {
                Util.info("未同意服务协议和隐私政策");
                return;
            }

            // that.$scope.is_send_phone = true;
            // return;
            if (!param.phone || !Util.isPhone(param.phone)) {
                that.LoginError('手机号码不合法！')
                return
            }

            if (!param.imgCode) {
                that.LoginError('请输入图片验证码！')
                return
            }

            that.getCode();
        },

        getCode: function () {
            var timeinterval = 60;
            var loginGetCodeTime = localStorage['loginGetCodeTime'];
            if (loginGetCodeTime) {
                loginGetCodeTime = parseInt(loginGetCodeTime);
                // 判断登录时间
                if (new Date().getTime() / 1000 - loginGetCodeTime < timeinterval) {
                    that.LoginError("操作过于频繁，请一分钟后再试");
                    return;
                }
            }

            var model = that.$scope.param;
            if (!model.imgCode) {
                that.LoginError("请输入图片验证码");
                return;
            }
            if (!model.phone) {
                that.LoginError("请输入手机号");
                return;
            }

            if (!Util.isPhone(model.phone)) {
                that.LoginError("手机号不合法", 3);
                return;
            }

            Util.ajax({
                method: "POST",
                data: {
                    phone: model.phone,
                    key: that.$scope.imgInfo.key,
                    code: model.imgCode
                },
                url: Util.getApiUrl("/auth/sendLoginCode", null, Config.auth_api)
            }, function (data) {
                localStorage['loginGetCodeTime'] = Math.round(new Date().getTime() / 1000);
                that.$scope.stopTime = timeinterval;
                that.$scope.is_send_phone = true;

                that.setTimer();

            }, true);
        },

        setTimer: function () {
            if (that.$scope.stopTime <= 0) return;

            that.$scope.stopTime--;
            that.$timeout(that.setTimer, 1000);
        },

        backSend: function () {
            var timeinterval = 60;
            var loginGetCodeTime = localStorage['loginGetCodeTime'];
            if (loginGetCodeTime) {
                loginGetCodeTime = parseInt(loginGetCodeTime);
                // 判断登录时间
                if (new Date().getTime() / 1000 - loginGetCodeTime < timeinterval) {
                    return;
                }
            }

            that.$scope.is_send_phone = false;
            that.changeImgUrl();
        },

        changeImgUrl: function () {
            Util.ajax({
                url: Util.getApiUrl("/auth/getIdentifyingCode", null, Config.auth_api)
            }, function (res) {
                that.$scope.imgInfo = res;
            });
        },

        //去除空格
        tirm: function (_phone) {
            var phone = _phone.split("").map(function (index, elem) {
                return elem != " ";
            });

            return phone;
        },

        //判断是否为手机并变换按钮颜色
        isPhone: function () {
            if (Util.isPhone(that.$scope.phone)) {
                that.$scope.code_btn_blue = true;
                that.$scope.is_show_del_icon = true;
            } else {
                that.$scope.code_btn_blue = false;
                that.$scope.is_show_del_icon = false;
            }

        },

        //判断验证码是否为空
        checkCode: function () {
            if (!that.$scope.code) {
                Util.info("获取验证码为空");
                return false;
            }
            return true;
        },

        //清除输入的手机号码并变换按钮颜色
        clearPhone: function () {
            that.$scope.phone = "";
            that.isPhone();
        },

        forGetPwd: function () {
            me.show("forGetPwd", {
                showType: 1,
                param: {}
            });
        },

        toNext: function () {
            var param = that.$scope.param;
            for (var key in param) {
                if (key.indexOf("code") == 0) {
                    param[key] = null;
                }
            }

            var value = $(".mycodelist-editor").val();
            if (value) {
                var arr = value.split("");
                arr.forEach((d, i) => {
                    param['code' + (i + 1)] = d;
                });
            }
        },

        popContent: function (type) {
            var setting = that.$scope.setting;
            var content = setting[type];
            if (!content) {
                Util.info("未维护内容，请联系管理员");
                return;
            }

            me.show("common/popContent/popContent", {
                showType: 2,
                param: {
                    content: content
                }
            });
        }
    });
})(jQuery);
