(function () {
    var that = me.define("articleList", {
        components: {},
        ctrl: function () {
            that.$scope.articleList = []
            that.$scope.showNoMore = false
            that.getArticleList()
        }, getArticleList(callback) {
            const requestData = {
                pageSize: 10,
                pageIndex: that.$scope.pageIndex,
                resourceType: 1
            };
            //从接口获取文章列表
            Util.ajax({
                url: Util.getApiUrl('/course/getList/resource', requestData, Config.auth_api)
            }, function (data) {
                that.$scope.dataCount = data.count;
                data.list.map(d => {
                    if (d.isDelete === 1) return;
                    that.$scope.articleList.unshift(
                        {
                            id: d.id,
                            title: d.title,
                            img: me.global.getUrl(d.face),
                            fabulous: d.likeCount === null ? 0 : d.likeCount,
                            readingVolume: d.viewCount === null ? 0 : d.viewCount,
                        }
                    )

                    if (that.$scope.dataCount <= that.$scope.articleList.length) {
                        that.$scope.showNoMore = true
                    }
                    callback && callback();
                })
            })

        }, onScroll: function (callback) {
            console.log(callback);
            if (that.$scope.dataCount <= that.$scope.articleList.length) {
                callback();
                return;
            }
            that.$scope.pageIndex += 1;
            that.getArticleList(callback);
        }, toArticleDetail: function (id) {
            Util.showPage("main/article/articleDetail", "科普文章详情", {id});
        },
    });
})();