(function () {
    var that = me.define("main", {
        components: {
            "mainHead": "pages/main/components/mainHead"
        },

        ctrl: function() {
            // Util.setAppTitle("中疾控戒烟","center");
            that.checkSurvey();
            that.initButton()
            that.initTip()
            that.initDayPunch()
            that.getTip()
            that.initData();
        },

        initData: function() {
            var user = me.global.userInfo;
            that.$scope.userInfo = {
                "id": 1,
                "name": user.realName,
                "planSpeed": user.stage / 5 * 100,
                "head": user.headimg,
                "userState": user.stage
            };
            that.$scope.stage = user.stage
            that.getUserStage(user.stage);

            //吸烟状态
            that.$scope.smokeState = {
                // startTime: new Date("2023-02-01 00:00:00"),//戒烟开始时间 为空未开始
                startTime: null, //戒烟开始时间 为空未开始
                times: 4, //烟瘾
                tar: 50, //焦油总量
                money: 524.50, //节省金钱
                total: 28, //累计少吸
                todayTar: 50, //今日焦油总量
                todayMoney: 2.50, //今日节省金钱
                lastTime: '11:50:00', //上次抽烟
                todayTotal: 5, //今日吸烟总量
            }
            //计算戒烟时间
            that.getTimeToQuitSmoking(that.$scope.smokeState)
        },

        checkSurvey: function () {
            var user = me.global.userInfo;
            if (!user.initialSurvey) {
                Util.showPage("questionnaire/questionnaire", "简短评估问卷", {}, function (isSave) {
                    if (!isSave) return;

                    location.reload();
                });
            }
        },

        //获取小卡片
        getTip() {
            Util.ajax({
                url: Util.getApiUrl('/course/getList/resource', {resourceType: 4}, Config.auth_api)
            }, function (data) {
                if (data.length > 0) {
                    that.$scope.tip = data[parseInt(Math.random() * data.length)].title
                }
            })
        },

        //获取用户阶段
        getUserStage(stage) {
            const userState = [{id: 1, name: '思考期', fontColor: '#3D7DC2', backgroundColor: '#D2EDFB'},
                {id: 2, name: '准备期', fontColor: '#C26600', backgroundColor: '#FFD8A1'},
                {id: 3, name: '行动期', fontColor: '#1D771D', backgroundColor: '#DDFFB9'},
                {id: 4, name: '复吸期', fontColor: '#A7403A', backgroundColor: '#FFEE00'},
                {id: 5, name: '维持期', fontColor: '#26458E', backgroundColor: '#A4BFFF'}
            ]
            //userState用户当前状态，关联userState的id, 如果为空显示未登录

            userState.forEach(us => {
                if (us.id === that.$scope.userInfo.userState) {
                    that.$scope.userInfo.userStateObj = us;
                    return false;
                }
            })

            switch (stage) {
                case 0:
                    that.$scope.labels = [
                        {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: 'my/report/report.html'},
                        {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;
                case 1:
                    that.$scope.labels = [
                        {
                            name: '诊断报告',
                            title: '您有1份评估报告',
                            bg: 'zdbg',
                            quitSmoking: '',
                            url: 'my/report/report.html' + that.$scope.userInfo.userState
                        },
                        {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;
                case 2: //准备期
                    that.$scope.labels = [
                        {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: 'my/report/report.html'},
                        {name: '戒烟日', title: '请设置您的戒烟日', bg: 'jyr', quitSmoking: '', url: 'main/smokeDay/smokeDay'},
                        {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;
                case 3: //行动期
                    that.$scope.labels = [
                        {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: 'my/report/report.html'},
                        {name: '一键求助', title: '解决烟瘾', bg: 'yjqz', quitSmoking: '', url: 'tools/sos/sos'},
                        {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;
                case 4: //维持期
                    that.$scope.labels = [
                        {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: 'my/report/report.html'},
                        {name: '一键求助', title: '解决烟瘾', bg: 'yjqz', quitSmoking: '', url: 'tools/sos/sos'},
                        {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;
                case 5: //复吸期
                    that.$scope.labels = [
                        {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: 'my/report/report.html'},
                        {
                            name: '减压训练',
                            title: '帮您减轻压力',
                            bg: 'jyxl',
                            quitSmoking: '',
                            url: 'tools/decompression/decompression'
                        }, {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;
                default:
                    that.$scope.labels = [
                        {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: 'my/report/report.html'},
                        {
                            name: '我的课程',
                            title: '您有新课程学习',
                            bg: 'wdkc',
                            quitSmoking: '',
                            url: 'main/curriculum/curriculum'
                        },
                    ];
                    break;

            }
            // that.$scope.labels = [
            //     {name: '诊断报告', title: '您有1份评估报告', bg: 'zdbg', quitSmoking: '', url: ''},
            //     // {name:'戒烟日',title:'请设置您的戒烟日',bg:'jyr',quitSmoking:'',url:''},
            //     // {name:'一键求助',title:'解决烟瘾',bg:'yjqz',quitSmoking:'',url:''},
            //     {name: '减压训练', title: '帮您减轻压力', bg: 'jyxl', quitSmoking: '', url: ''},
            //     // {name:'戒烟日还有',title:'请设置您的戒烟日',bg:'jyrhy',quitSmoking:'3',url:''},
            //     {
            //         name: '我的课程',
            //         title: '您有新课程学习',
            //         bg: 'wdkc',
            //         quitSmoking: '',
            //         url: 'main/curriculum/curriculum'
            //     },
            // ]
        },
        getTimeToQuitSmoking(smokeState) {
            if (smokeState.startTime) {
                smokeState.startDay = smokeState.startTime.getMonth() +
                    1 + '月' + smokeState.startTime.getDate() + '日';
                that.getAddTime(smokeState.startTime)

                setInterval(() => {
                    that.getAddTime(smokeState.startTime)
                }, 1000)
            }
        },
        getAddTime(startTime) {
            const subtime = (new Date() - startTime) / 1000; //计算时间差,并将毫秒转化为秒
            const days = parseInt(subtime / 86400); //天  24*60*60*1000
            const hours = parseInt(subtime / 3600) - 24 * days; //小时  60*60  总小时数-过去小时数=现在小时数
            const mins = parseInt(subtime % 3600 / 60); //分钟 - (day*24)  以60秒为一整份  取余 剩下秒数 秒数/60就是分钟数
            const secs = parseInt(subtime % 60); //以60秒为一整份  取余  剩下秒数
            document.getElementById('addTime').innerHTML = `<div>${days}<span>天</span></div><div>${(hours > 9 ? hours : '0' + hours)
            + ':' + (mins > 9 ? mins : '0' + mins) + ':' + (secs > 9 ? secs : '0' + secs)}</div>`
        },
        initTip() {

        },
        initDayPunch() {
            Util.ajax({
                url: Util.getApiUrl('/course/punch/listUserPunchWeek', null, Config.auth_api)
            }, function (data) {
                that.$scope.dailyClocks = []
                for (let i = 0; i < 7; i++) {
                    let checkState = 0; //是否打卡  0忘记打卡 1已打卡 2今天未打卡 3未来打卡
                    data.map(d => {
                        if (d.punchDate === that.getDay(0 - i)) {
                            checkState = 1;
                        }
                    })
                    if (i === 0 && checkState === 0) {
                        checkState = 2;
                    }
                    that.$scope.dailyClocks.unshift({
                        name: that.getDay(0 - i).substring(5),
                        checkState: checkState,
                        date: that.getDay(0 - i)
                    })
                }
            })
        },
        getDay(day) {
            const today = new Date();

            const targetday_milliseconds = today.getTime() + 1000 * 60 * 60 * 24 * day;

            today.setTime(targetday_milliseconds);

            let tYear = today.getFullYear();

            let tMonth = today.getMonth();

            let tDate = today.getDate();

            tMonth = (tMonth + 1) > 10 ? (tMonth + 1) : '0' + (tMonth + 1);

            tDate = (tDate) > 10 ? (tDate) : '0' + (tDate);

            return tYear + "-" + tMonth + "-" + tDate;
        },
        initButton() {
            that.$scope.buttons = [
                {name: '工具箱', index: 4, showType: 0},
                {name: '积分', url: 'my/integral/integral', showType: 1},
                {name: '戒烟资源库', index: 2, showType: 0},
                {name: '我的足迹', url: '', showType: 1},
                {name: '医生在线', index: 3, showType: 0},
                {name: '戒烟健康检测', url: 'my/healthTest/healthTest', showType: 1},
                {name: '个人中心', index: 5, showType: 0},
                {name: '戒烟计划', url: 'my/plan/plan', showType: 1},
            ]
        },
        buttonClick(item) {
            if (item.showType === 0) {
                index.switchMenu(item.index);
                // location.href = 'index.html?m=' + item.url
            } else {
                that.goPage(item.url, item.name)
            }
        },
        goPage(url, title) {
            Util.showPage(url, title, {stage: that.$scope.stage});
        },
        goPunch(date) {
            Util.showPage("main/punch/punch", '戒烟打卡', {date});
        },
        onScrollIng: function(scrollTop) {
            if (scrollTop > 5) {
                $(".mainIndex .push").css({
                    zIndex: 1
                });
            } else {
                 $(".mainIndex .push").css({
                    zIndex: 101
                });
            }
        }
    });
})();