(function () {
    var that = me.define("punchData", {
        components: {
            "comNoData": "components/nodata/comNoData"
        },
        ctrl: function () {
            that.$scope.chooseXyl = 1
            that.$scope.chooseYy = 1
            that.$scope.history = []
            that.getChart()
            that.getHistory()
        }, getHistory() {

            const userInfo = localStorage.getItem('accountInfo')
            console.log(userInfo);
            Util.ajax({
                url: Util.getApiUrl('/course/getList/punch', {userId: 1}, Config.auth_api)
            }, function (data) {
                console.log(data);
                const place = ['家里', '公司', '其他']
                const person = ['独自', '朋友', '同事', '家人', '其他']
                const time = ['上午', '中午', '下午', '晚上']
                data.map(item => {
                    if (item.status === 2 && item.isDelete === 0) {
                        that.$scope.history.unshift({
                            time: item.smokeTime === null ? '无' : place[item.smokeTime],
                            area: item.smokePlace === null ? '无' : time[item.smokePlace],
                            person: item.smokeWith === null ? '无' : person[item.smokeWith],
                            degree: item.smokeLevel,
                            result: item.memo === null ? '无' : item.memo
                        })
                    }
                })
            })
        }, getChart() {
            for (let i = 1; i < 4; i++) {
                Util.ajax({
                    url: Util.getApiUrl('/course/punch/getCigaretteTotal', {searchType: i}, Config.auth_api)
                }, function (data) {
                    const tempList = []
                    that.getDay(i).forEach(d => {
                        let flag = false
                        for (const dElement in data) {
                            if (d === dElement) {
                                tempList.push({day: d, value: data[dElement]})
                                flag = true
                            }
                        }
                        if (!flag) {
                            tempList.push({day: d, value: 0})
                        }
                    })
                    if (i === 1) {
                        that.$scope.weekXylList = tempList
                        that.getXylChart(1)
                    } else if (i === 2) {
                        that.$scope.monthXylList = tempList
                    } else {
                        that.$scope.yearXylList = tempList
                    }
                });

                Util.ajax({
                    url: Util.getApiUrl('/course/punch/getSmokePunchTotal', {searchType: i}, Config.auth_api)
                }, function (data) {
                    const tempList2 = []
                    that.getDay(i).forEach(d => {
                        let flag = false
                        for (const dElement in data) {
                            if (d === dElement) {
                                tempList2.push({day: d, value: data[dElement]})
                                flag = true
                            }
                        }
                        if (!flag) {
                            tempList2.push({day: d, value: 0})
                        }
                    })
                    if (i === 1) {
                        that.$scope.weekYyList = tempList2
                        that.getYyChart(1)
                    } else if (i === 2) {
                        that.$scope.monthYyList = tempList2
                    } else {
                        that.$scope.yearYyList = tempList2
                    }
                });
            }
        },
        //获取日期 type 1最近7天 2最近4周 3最近4月
        getDay(type) {
            console.log(type);
            const today = new Date();
            const returnDate = [];
            if (type === 1) {
                for (let i = 0; i < 7; i++) {
                    const milliseconds = today.getTime() - 1000 * 60 * 60 * 24 * i;
                    const tempDate = new Date(milliseconds);
                    let tYear = tempDate.getFullYear();
                    let tMonth = tempDate.getMonth();
                    let tDate = tempDate.getDate();
                    tMonth = (tMonth + 1) > 10 ? (tMonth + 1) : '0' + (tMonth + 1);
                    tDate = (tDate) > 10 ? (tDate) : '0' + (tDate);
                    returnDate.unshift(tYear + "-" + tMonth + "-" + tDate);
                }
            } else if (type === 2) {
                for (let i = 0; i < 4; i++) {
                    returnDate.unshift(that.getWeek(today.getTime() - 1000 * 60 * 60 * 24 * 7 * i))
                }
            } else {
                let tYear = new Date().getFullYear();
                let tMonth = new Date().getMonth();
                //获取最近4个月时间
                for (let i = 0; i < 4; i++) {
                    tMonth = tMonth - 1;
                    if (tMonth < 0) {
                        tYear = tYear - 1;
                        tMonth = 11;
                    }
                    returnDate.unshift(tYear + "-" + (tMonth + 1));
                }
            }
            return returnDate;
        }, getWeek(temp_ms) {
            let temptTime = new Date(temp_ms);
            // 今天周几，如果是周日，则设为7
            let weekday = temptTime.getDay() & 7;
            // 周1+5天=周六，得到本周6的日期,之所以以每周末的日期为基准，不能用每周日的日期为基准来计算
            // 当前日期的周六的日期
            temptTime.setDate(temptTime.getDate() - weekday + 1 + 5);
            // 每年的第一天，年/1/1，参数之中，0代表月份，介于0(1月) ~11(12月)之间的整数，getDay获取星期几同理
            // 第一天的日期
            let firstDay = new Date(temptTime.getFullYear(), 0, 1);
            let dayOfWeek = firstDay.getDay();
            let spendDay = 1;
            // 如果第一天不是星期日，那么就找到下一个星期日作为开始
            if (dayOfWeek !== 0) {
                spendDay = 7 - dayOfWeek + 1;
            }
            let yearOfW = temptTime.getFullYear();
            firstDay = new Date(yearOfW, 0, 1 + spendDay);
            /*
            1.Math.ceil 取大于等于所给值的最小整数
            2.86400000是换算到天的基数，js的时间差值为时间戳，即毫秒数
              1000毫秒 * 60秒 * 60分钟* 24小时 = 86400000
            3.temptTime是当前日期，firstDay是当年第一天，周数计算公式就是（当前日期-第一天天数）/7 就是本年的第几周
            4.d是差距天数，res是周数
            */
            let d = Math.ceil((temptTime.valueOf() - firstDay.valueOf()) / 86400000);
            let res = Math.ceil(d / 7) + 1;
            return firstDay.getFullYear().toString() + "-" + res.toString();
        }, getXylChart(type) {
            that.$scope.chooseXyl = type
            let xyl = echarts.init(document.getElementById('xyl'));
            let xdata = [], ydata = [], total = []
            if (type === 1) {
                total = that.$scope.weekXylList
            } else if (type === 2) {
                total = that.$scope.monthXylList
            } else {
                total = that.$scope.yearXylList
            }
            total.forEach(week => {
                xdata.push(week.day)
                ydata.push(week.value)
            })
            xyl.setOption({
                xAxis: {
                    type: 'category',
                    data: xdata,
                    axisLine: {show: false},
                    axisTick: {show: false},
                }, grid: {
                    left: 20,
                    top: 12,
                    bottom: 20,
                    right: 12
                }, color: ['#FB8160'],
                yAxis: {
                    type: 'value',
                    axisLine: {
                        show: false
                    }
                },
                series: [
                    {
                        lineStyle: {color: '#FB8160'},

                        data: ydata,
                        type: 'line'
                    }
                ]
            });
        }, getYyChart(type) {
            that.$scope.chooseYy = type
            let yy = echarts.init(document.getElementById('yy'));
            let xdata = [], ydata = [], total = []
            if (type === 1) {
                total = that.$scope.weekYyList
            } else if (type === 2) {
                total = that.$scope.monthYyList
            } else {
                total = that.$scope.yearYyList
            }
            total.forEach(week => {
                xdata.push(week.day)
                ydata.push(week.value)
            })
            yy.setOption({
                xAxis: {
                    type: 'category',
                    data: xdata,
                    axisLine: {show: false},
                    axisTick: {show: false},
                }, grid: {
                    left: 20,
                    top: 12,
                    bottom: 20,
                    right: 12
                }, color: ['#FB8160'],
                yAxis: {
                    type: 'value',
                    axisLine: {
                        show: false
                    }
                },
                series: [
                    {
                        lineStyle: {color: '#FB8160'},

                        data: ydata,
                        type: 'line'
                    }
                ]
            });
        }
    });
})();