(function () {
    var that = me.define("qaa", {
        ctrl: function () {
            that.$scope.type = 2;
            that.$scope.list = [];
            that.$scope.pageIndex = 0;
            that.$scope.dataCount = 0;
            that.initList();
        },
        changeType: function () {
            that.$scope.type = that.$scope.type === 1 ? 2 : 1;
            that.initList();
        },
        initList: function (callback) {
            if (that.$scope.type === 2) {
                let list = [];
                Util.ajax({
                    data: {
                        pageIndex: that.$scope.pageIndex,
                        pageSize: 10,
                        userId: me.param().info.id
                    },
                    url: Config.apiPre + "/course/getList/ask"
                }, function (data) {
                    list = data.list;

                    let ids = "";
                    for (let i = 0; i < data.list.length; i++) {
                        if (ids !== "") ids += ",";
                        ids += data.list[i].id;
                    }
                    Util.ajax({
                        data: {
                            askId: ids
                        },
                        url: Config.apiPre + "/course/getList/askReply"
                    }, function (data2) {
                        if (data2.length > 0) {
                            for (let i = 0; i < data.list.length; i++) {
                                let ask = data.list[i];
                                for (let j = 0; j < data2.length; j++) {
                                    let answer = data2[j];
                                    if (ask.id === answer.askId) {
                                        if (!ask.list) ask.list = [];
                                        ask.list.push(answer);
                                    }
                                }
                            }
                        }
                        that.$scope.dataCount = data.count;
                        Util.merge(that.$scope.list, list);

                        callback && callback();
                    });
                });
            } else {
                Util.ajax({
                    data: {
                        accountId: me.param().info.id
                    },
                    url: Config.apiPre + "/course/getList/askReply"
                }, function (data2) {
                    if (data2.length > 0) {
                    } else {
                        that.$scope.list = [];
                    }
                    callback && callback();
                });
            }
        },
        delAsk: function (id) {
            Util.ajax({
                data: {
                    ids: id
                },
                url: Config.apiPre + "/course/del/ask"
            }, function (data) {
                that.initList();
            });
        },
        delAnswer: function(id){
            Util.ajax({
                data: {
                    ids: id
                },
                url: Config.apiPre + "/course/del/askReply"
            }, function (data) {
                that.initList();
            });
        },
        onScroll: function (callback) {
            if (that.$scope.dataCount <= that.$scope.data.length) {
                callback();
                return;
            }
            that.$scope.pageIndex += 1;
            that.initList(callback);
        },
    });
})();