(function () {
    var that = me.define("myQuestionnaire", {
        components: {},

        ctrl: function () {
            that.$scope.list = {
                recordB1:
                    {
                        title: '您现在吸烟吗？（单选）', answerList:
                            ['每天吸,<input type="number" class="number" name="recordB1Memo" ng-model="param.recordB1Memo" onchange="angular.element(this).scope().change(this)"/>支/日',
                                '不是每天吸，偶尔吸',
                                '已戒烟，戒烟时间：<input type="number" class="number" name="recordB1Memo" ng-model="answers.recordB1Memo" onchange="angular.element(this).scope().change(this)"/>天',
                                '从不吸烟'],
                        rule: {
                            2: 9
                        },
                        memo: [1, 3]
                    },
                recordB2: {
                    title: '您吸烟多少年了？',
                    answerList: ['<input type="number" class="number" name="recordB2"/>年']
                },
                recordB3: {
                    title: '您起床后多久吸第一支烟？（单选）', answerList: ['5分钟内',
                        '6至30分钟内',
                        '31至60分钟内',
                        '60分钟后']
                },
                recordB4: {
                    title: '在不准吸烟的区域（例如商场的非吸烟区、公交车内），您觉得忍住不吸烟会很难吗？（单选）', answerList: ['会',
                        '不会']
                },
                recordB5: {
                    title: '您觉得哪一支烟最难放弃？（单选）', answerList: ['早上第一支',
                        '其他']
                },
                recordB6: {
                    title: '起床后的几个小时内您吸烟次数会比在其他时间内的次数多吗？（单选）', answerList: ['会',
                        '不会']
                },
                recordB7: {
                    title: '当您因为生病需要大部分时间卧床时，您会吸烟吗？（单选）', answerList: ['会',
                        '不会']
                },
                recordB8: {
                    title: '您购买一包卷烟（20支）的平均花费是多少元？',
                    answerList: ['<input type="number" class="number" name="recordB8"/>元']
                },
                recordC1: {
                    title: '下面哪项最符合您现在关于戒烟的想法? （单选）', answerList: ['我准备在1个月内戒烟',
                        '我想戒烟，但不会在1个月内',
                        '不想戒烟或不清楚']
                },
                recordD1: {
                    title: '您是否患有以下疾病情况？（可多选）', answerList: ['无',
                        '高血压',
                        '糖尿病',
                        '高血脂',
                        '冠心病',
                        '脑梗死/中风',
                        '慢性支气管炎/慢阻肺',
                        '支气管哮喘',
                        '恶性肿瘤',
                        '其他<input type="text" class="memo" name="recordB8Memo"/>'],
                    memo: [10]
                },
                recordE1: {
                    title: '您这次决定戒烟的最主要原因是?',
                    answerList: ['知道吸烟危害健康，想过健康生活',
                        '健康状况在逐步下降',
                        '知道有人因为吸烟而患病',
                        '家人要我戒烟',
                        '不想家人／朋友吸入二手烟',
                        '正在备孕已经怀孕',
                        '避免在禁烟场所引起麻烦',
                        '改善仪容、消除烟味',
                        '不想成为孩子的坏榜样1',
                        '其它<input type="text" class="memo"/>'],
                    memo: [10]
                },
                recordE2: {
                    title: '您觉得什么能够帮助您增强戒烟决心？（可多选）',
                    answerList: ['更多的关于吸烟危害的信息（比如吸烟相关疾病的图片或视频）',
                        '让我相信自己能够成功戒烟的信息',
                        '找到一个合适的戒烟时机或理由',
                        '其他<input type="text" class="memo"/>'],
                    memo: [4]
                },
                detailA1: {
                    title: '您过去是否尝试过戒烟（戒烟时间超过24小时）？（单选）',
                    answerList: ['否',
                        '是'],
                    rule: {
                        1: 18
                    }
                },
                detailA2: {
                    title: '您最长一次戒烟持续了多长时间? （单选）', answerList: ['1个月以内',
                        '1个月以上']
                },
                detailA3: {
                    title: '您是否使用过下列方式戒烟? （可多选）',
                    answerList: ['干戒（不能与其他选项同选）',
                        '行为替代（比如吃零食等）',
                        '向医护人员咨询',
                        '用自助戒烟资料',
                        '使用药物（尼古丁替代治疗，安非他酮，伐尼克兰）',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [6]
                },
                detailA4: {
                    title: '您过去戒烟时是否出现过下列某些症状让您感到难以忍受？（多选）',
                    answerList: ['没有这些症状',
                        '头痛',
                        '易怒',
                        '睡眠不好',
                        '恶心呕吐',
                        '坐立不安',
                        '注意力不集中',
                        '强烈的吸烟渴望',
                        '情绪低落',
                        '爱哭和情绪激动',
                        '总是觉得累',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [12]
                },
                detailA5: {
                    title: '您复吸的原因？（可多选）', answerList: ['烟瘾发作难以克服',
                        '身边其他吸烟者的影响',
                        '没有信心',
                        '压力事件',
                        '紧张、焦虑、心情郁闷',
                        '体重上升',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [7]
                },
                detailB1: {
                    title: '研究表明，在您想要戒烟的时候立即行动能够增加戒烟成功率，我们建议您现在设定一个戒烟日。请告诉我们您准备如何设定戒烟日？（单选）',
                    answerList: ['我不准备戒烟',
                        '我还没有决定好要不要戒烟',
                        '我想要戒烟，但是还没有设定戒烟日',
                        '我已经决定戒烟了，并且设定好了戒烟日',
                        '我现在正在尝试戒烟',
                        '我已经戒烟了'],
                    rule: {
                        3: 20,
                        4: 20,
                        5: 20,
                        6: 20
                    }
                },
                detailB2: {
                    title: '您没有准备好戒烟的原因是？', answerList: ['认为吸烟对健康危害不大或自身健康良好不担心患病',
                        '认为吸烟有助于我完成工作或进行社交',
                        '戒烟太难或太痛苦，没有毅力和信心能坚持下来']
                },
                detailB3: {
                    title: '您有多大信心可以从此不再吸烟？（0表示信心最小，10表示信心最大）', answerList: []
                },
                detailC1: {
                    title: '您觉得戒烟有多困难？（0表示难度最低，10表示难度最高）', answerList: []
                },
                detailC2: {
                    title: '假如尝试戒烟，您认为较难处理的情况是什么？（最多3项）',
                    maxLen: 3,
                    answerList: ['烟瘾发作时',
                        '当感到有压力（工作、人际关系、财务等）或情绪波动时',
                        '身边有其他吸烟者时',
                        '喝酒时',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [5]
                },
                detailC3: {
                    title: '您喝酒（频率大于每周三次）吗？', answerList: ['不喝',
                        '喝']
                },
                detailC4: {
                    title: '您周围经常接触的人是否有吸烟者？', answerList: ['否',
                        '是（请答方格内的问题）'],
                    rule: {
                        1: 26
                    }
                },
                detailC5: {
                    title: '在你戒烟过程中，你愿意向谁寻求支持（可多选）？', answerList: ['配偶',
                        '父母',
                        '子女',
                        '朋友',
                        '同事',
                        '医护人员',
                        '其他<input type="text" class="memo"/>',
                        '没有（不能与其他选项同选）'],
                    memo: [7],
                    only: [8]
                },
                detailC6: {
                    title: '最近1周，您的心情如何？', answerList: []
                },
                detailC7: {
                    title: '您准备在什么时候开始戒烟（单选）？',
                    answerList: ['立刻', '一周内', '暂不开始']
                }
            };
            that.$scope.run = [];
            that.$scope.answers = {}; //用于存储结果，多选存字符串
            that.$scope.answers2 = {}; //用于存储结果，多选存集合
            that.$scope.user = {};
            that.$scope.show = {};

            Util.ajax({
                data: {
                    pageIndex: 0,
                    pageSize: 10
                },
                url: Config.apiPre + "/main/getUser"
            }, function (info) {
                that.$scope.user = info;
                if (info.birthday)
                    that.$scope.user.age = new Date().getFullYear() - info.birthday.substring(0, 4);
                Util.ajax({
                    url: Config.apiPre + "/main/get/userRecord/" + info.id
                }, function (data) {
                    that.$scope.answers = data;
                    let answers2 = {};
                    for (let i in data) {
                        if (data[i]) {
                            answers2[i] = {};
                            if (i === 'detailC6') {
                                const arrays = ['从不', '很少', '有时', '经常', '一直'];
                                for (let j = 0; j < 5; j++) {
                                    answers2[i + (j + 1)] = arrays[data[i].split(",")[j] - 1];
                                }
                            } else if (typeof data[i] === 'string' && data[i].indexOf(",") !== 0) {
                                for (let j = 0; j < data[i].split(",").length; j++) {
                                    answers2[i][data[i].split(",")[j]] = true;
                                }
                            } else if (data[i]) {
                                let val = data[i] + '';
                                answers2[i][val] = true;
                            }
                            that.$scope.show[i] = true;
                        }else{
                            that.$scope.show[i] = false;
                        }
                    }
                    that.$scope.answers2 = answers2;
                });
            });
        }
    });
})();