(function () {
    var that = me.define("questionnaire", {
        components: {},

        ctrl: function () {
            that.$scope.param = {};
            that.$scope.list = [
                {
                    index: 1,
                    code: 'recordB1', title: '您现在吸烟吗？（单选）', type: 'radio', answerList:
                        ['每天吸,<input type="number" class="number" name="recordB1Memo" ng-model="param.recordB1Memo" onchange="angular.element(this).scope().change(this)"/>支/日',
                            '不是每天吸，偶尔吸',
                            '已戒烟，戒烟时间：<input type="number" class="number" name="recordB1Memo" ng-model="answers.recordB1Memo" onchange="angular.element(this).scope().change(this)"/>天',
                            '从不吸烟'],
                    rule: {
                        2: 9
                    },
                    memo: [1, 3]
                },
                {
                    index: 2,
                    code: 'recordB2',
                    title: '您吸烟多少年了？',
                    answerList: ['<input type="number" class="number" name="recordB2"/>年']
                },
                {
                    index: 3,
                    code: 'recordB3', title: '您起床后多久吸第一支烟？（单选）', type: 'radio',
                    answerList: ['5分钟内',
                        '6至30分钟内',
                        '31至60分钟内',
                        '60分钟后']
                },
                {
                    index: 4,
                    code: 'recordB4', title: '在不准吸烟的区域（例如商场的非吸烟区、公交车内），您觉得忍住不吸烟会很难吗？（单选）', type: 'radio',
                    answerList: ['会',
                        '不会']
                },
                {
                    index: 5,
                    code: 'recordB5', title: '您觉得哪一支烟最难放弃？（单选）', type: 'radio',
                    answerList: ['早上第一支',
                        '其他']
                },
                {
                    index: 6,
                    code: 'recordB6', title: '起床后的几个小时内您吸烟次数会比在其他时间内的次数多吗？（单选）', type: 'radio',
                    answerList: ['会',
                        '不会']
                },
                {
                    index: 7,
                    code: 'recordB7', title: '当您因为生病需要大部分时间卧床时，您会吸烟吗？（单选）', type: 'radio',
                    answerList: ['会',
                        '不会']
                },
                {
                    index: 8,
                    code: 'recordB8', title: '您购买一包卷烟（20支）的平均花费是多少元？',
                    answerList: ['<input type="number" class="number" name="recordB8"/>元']
                },
                {
                    index: 9,
                    code: 'recordC1', title: '下面哪项最符合您现在关于戒烟的想法? （单选）', type: 'radio',
                    answerList: ['我准备在1个月内戒烟',
                        '我想戒烟，但不会在1个月内',
                        '不想戒烟或不清楚']
                },
                {
                    index: 10,
                    code: 'recordD1', title: '您是否患有以下疾病情况？（可多选）', type: 'checkbox',
                    answerList: ['无',
                        '高血压',
                        '糖尿病',
                        '高血脂',
                        '冠心病',
                        '脑梗死/中风',
                        '慢性支气管炎/慢阻肺',
                        '支气管哮喘',
                        '恶性肿瘤',
                        '其他<input type="text" class="memo" name="recordB8Memo"/>'],
                    memo: [10]
                },
                {
                    index: 11,
                    code: 'recordE1', title: '您这次决定戒烟的最主要原因是?',
                    type: 'checkbox',
                    answerList: ['知道吸烟危害健康，想过健康生活',
                        '健康状况在逐步下降',
                        '知道有人因为吸烟而患病',
                        '家人要我戒烟',
                        '不想家人／朋友吸入二手烟',
                        '正在备孕已经怀孕',
                        '避免在禁烟场所引起麻烦',
                        '改善仪容、消除烟味',
                        '不想成为孩子的坏榜样1',
                        '其它<input type="text" class="memo"/>'],
                    memo: [10]
                },
                {
                    index: 12,
                    code: 'recordE2',
                    title: '您觉得什么能够帮助您增强戒烟决心？（可多选）',
                    type: 'checkbox',
                    answerList: ['更多的关于吸烟危害的信息（比如吸烟相关疾病的图片或视频）',
                        '让我相信自己能够成功戒烟的信息',
                        '找到一个合适的戒烟时机或理由',
                        '其他<input type="text" class="memo"/>'],
                    memo: [4]
                },
                {
                    index: 13,
                    code: 'detailA1',
                    title: '您过去是否尝试过戒烟（戒烟时间超过24小时）？（单选）',
                    type: 'radio',
                    answerList: ['否',
                        '是'],
                    rule: {
                        1: 18
                    }
                },
                {
                    index: 14,
                    code: 'detailA2', title: '您最长一次戒烟持续了多长时间? （单选）', type: 'radio', answerList: ['1个月以内',
                        '1个月以上']
                },
                {
                    index: 15,
                    code: 'detailA3',
                    title: '您是否使用过下列方式戒烟? （可多选）',
                    type: 'checkbox',
                    answerList: ['干戒（不能与其他选项同选）',
                        '行为替代（比如吃零食等）',
                        '向医护人员咨询',
                        '用自助戒烟资料',
                        '使用药物（尼古丁替代治疗，安非他酮，伐尼克兰）',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [6]
                },
                {
                    index: 16,
                    code: 'detailA4',
                    title: '您过去戒烟时是否出现过下列某些症状让您感到难以忍受？（多选）',
                    type: 'checkbox',
                    answerList: ['没有这些症状',
                        '头痛',
                        '易怒',
                        '睡眠不好',
                        '恶心呕吐',
                        '坐立不安',
                        '注意力不集中',
                        '强烈的吸烟渴望',
                        '情绪低落',
                        '爱哭和情绪激动',
                        '总是觉得累',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [12]
                },
                {
                    index: 17,
                    code: 'detailA5', title: '您复吸的原因？（可多选）', type: 'checkbox', answerList: ['烟瘾发作难以克服',
                        '身边其他吸烟者的影响',
                        '没有信心',
                        '压力事件',
                        '紧张、焦虑、心情郁闷',
                        '体重上升',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [7]
                },
                {
                    index: 18,
                    code: 'detailB1',
                    title: '研究表明，在您想要戒烟的时候立即行动能够增加戒烟成功率，我们建议您现在设定一个戒烟日。请告诉我们您准备如何设定戒烟日？（单选）',
                    type: 'radio',
                    answerList: ['我不准备戒烟',
                        '我还没有决定好要不要戒烟',
                        '我想要戒烟，但是还没有设定戒烟日',
                        '我已经决定戒烟了，并且设定好了戒烟日',
                        '我现在正在尝试戒烟',
                        '我已经戒烟了'],
                    rule: {
                        3: 20,
                        4: 20,
                        5: 20,
                        6: 20
                    }
                },
                {
                    index: 19,
                    type: 'checkbox',
                    code: 'detailB2', title: '您没有准备好戒烟的原因是？', answerList: ['认为吸烟对健康危害不大或自身健康良好不担心患病',
                        '认为吸烟有助于我完成工作或进行社交',
                        '戒烟太难或太痛苦，没有毅力和信心能坚持下来']
                },
                {
                    index: 20,
                    code: 'detailB3', title: '您有多大信心可以从此不再吸烟？（0表示信心最小，10表示信心最大）', answerList: []
                },
                {
                    index: 21,
                    code: 'detailC1', title: '您觉得戒烟有多困难？（0表示难度最低，10表示难度最高）', answerList: []
                },
                {
                    index: 22,
                    code: 'detailC2',
                    title: '假如尝试戒烟，您认为较难处理的情况是什么？（最多3项）',
                    type: 'checkbox',
                    maxLen: 3,
                    answerList: ['烟瘾发作时',
                        '当感到有压力（工作、人际关系、财务等）或情绪波动时',
                        '身边有其他吸烟者时',
                        '喝酒时',
                        '其他，请说明<input type="text" class="memo"/>'],
                    memo: [5]
                },
                {
                    index: 23,
                    type: 'radio',
                    code: 'detailC3', title: '您喝酒（频率大于每周三次）吗？', answerList: ['不喝',
                        '喝']
                },
                {
                    index: 24,
                    type: 'radio',
                    code: 'detailC4', title: '您周围经常接触的人是否有吸烟者？', answerList: ['否',
                        '是（请答方格内的问题）'],
                    rule: {
                        1: 26
                    }
                },
                {
                    index: 25,
                    type: 'checkbox',
                    code: 'detailC5', title: '在你戒烟过程中，你愿意向谁寻求支持（可多选）？', answerList: ['配偶',
                        '父母',
                        '子女',
                        '朋友',
                        '同事',
                        '医护人员',
                        '其他<input type="text" class="memo"/>',
                        '没有（不能与其他选项同选）'],
                    memo: [7],
                    only: [8]
                },
                {
                    index: 26,
                    code: 'detailC6', title: '最近1周，您的心情如何？', answerList: []
                },
                {
                    index: 27,
                    code: 'detailC7',
                    title: '您准备在什么时候开始戒烟（单选）？',
                    type: 'radio',
                    answerList: ['立刻', '一周内', '暂不开始']
                },
            ];
            that.$scope.run = [];
            that.$scope.answers = {}; //用于存储结果，多选存字符串
            that.$scope.answers2 = {}; //用于存储结果，多选存集合
            that.$scope.qindex = 0;
            that.$scope.curr = {};
            that.$scope.last = false;
            that.$scope.user = {};
        },

        toNext() {
            if (that.$scope.qindex === 0) {
                if (!that.$scope.user.sex || !that.$scope.user.age || !that.$scope.user.education) {
                    Util.info('请输入！');
                    return false;
                }
                that.$scope.qindex = 1;
                that.$scope.curr = that.$scope.list[that.$scope.qindex - 1];
            } else {
                let curr = that.$scope.curr;
                if (!that.$scope.answers[curr.code]) {
                    Util.info('请输入！');
                    return false;
                } else if (curr.memo && curr.memo.length > 0) {
                    let vals = that.$scope.answers[curr.code];
                    for (let i = 0; i < vals.split(",").length; i++) {
                        let existsMemo = false;
                        for (let j = 0; j < curr.memo.length; j++) {
                            if (vals[i] == curr.memo[j]) {
                                existsMemo = true;
                            }
                        }
                        if (existsMemo && !that.$scope.answers[curr.code + "Memo"]) {
                            Util.info('请输入！');
                            return false;
                        }
                    }
                }
                if (that.$scope.qindex === 27 || (that.$scope.qindex === 1 && that.$scope.answers2['recordB1']['4'])) {
                    let userRecord = that.$scope.answers;
                    if (that.$scope.qindex === 27 && that.$scope.answers.detailC7 !== '3') {
                        userRecord.stage = 1;
                    }
                    Util.ajax({
                        data: {
                            user: that.$scope.user,
                            userRecord: userRecord
                        },
                        url: Config.apiPre + "/main/saveInitSurveyData",
                        isJson: true
                    }, function (data) {
                        Util.hidePage(true);
                    });
                    return false;
                }

                if (that.$scope.qindex === 24) {
                    if (that.$scope.answers[curr.code] === '2') {
                        for (let i = 1; i <= 6; i++) {
                            if (!that.$scope.answers[curr.code + i]) {
                                Util.info('请输入！');
                                return false;
                            } else if (i === 1 && that.$scope.answers[curr.code + i] === '2' && !that.$scope.answers[curr.code + i + "Num"]) {
                                Util.info('请输入！');
                                return false;
                            }
                        }
                    }
                }
                if (that.$scope.qindex === 26) {
                    if (that.$scope.answers[curr.code].split(",").length !== 5) {
                        Util.info('请选择！');
                        return false;
                    }
                }

                let answer = that.$scope.answers[curr.code];
                if (that.$scope.curr.rule && that.$scope.curr.rule[answer]) {
                    that.$scope.qindex = that.$scope.curr.rule[answer];
                    that.$scope.curr = that.$scope.list[that.$scope.curr.rule[answer] - 1];
                } else {
                    that.$scope.qindex += 1;
                    that.$scope.curr = that.$scope.list[that.$scope.qindex - 1];
                }
                that.$scope.run.push(curr);
            }
        },
        toPrev() {
            if (that.$scope.qindex === 1) {
                that.$scope.qindex = 0;
                that.$scope.curr = {};
            } else {
                that.$scope.curr = that.$scope.run[that.$scope.run.length - 1];
                that.$scope.run.pop();
                that.$scope.qindex = that.$scope.curr.index;
            }
        },
        choose(index) {
            let val = index + '';
            let curr = that.$scope.curr;
            if (curr.type === 'radio') {
                that.$scope.answers[curr.code] = val;
                that.$scope.answers2[curr.code] = {};
                that.$scope.answers2[curr.code][val] = true;

                if (curr.memo && curr.memo.length > 0) {
                    if (curr.memo.length === 1 && curr.memo[0] != val) {
                        that.$scope.answers[curr.code + 'Memo'] = '';
                    } else {
                        for (let i = 0; i < curr.memo.length; i++) {
                            if (curr.memo[i] != val) {
                                that.$scope.answers[curr.code + 'Memo' + curr.memo[i]] = '';
                            }
                        }
                    }
                }
            } else if (curr.type === 'checkbox') {
                let answer = that.$scope.answers[curr.code];

                let only = false;
                let existsOnly = false;
                if (curr.only && curr.only.length > 0) {
                    for (let i = 0; i < curr.only.length; i++) {
                        if (curr.only[i] === index) {
                            only = true;
                        }
                    }
                    existsOnly = true;
                }
                if (!answer || only) {
                    that.$scope.answers[curr.code] = val + '';
                    that.$scope.answers2[curr.code] = {};
                    that.$scope.answers2[curr.code][val] = true;
                    if (only && that.$scope.answers[curr.code + "Memo"]) {
                        that.$scope.answers[curr.code + "Memo"] = '';
                    }
                } else {
                    let vals = "";
                    let exists = false;
                    for (let j = 0; j < answer.split(",").length; j++) {
                        if (!only && existsOnly && curr.only[0] == answer.split(",")[j]) {
                            delete that.$scope.answers2[curr.code][answer.split(",")[j]];
                        } else if (answer.split(",")[j] !== val) {
                            if (vals !== '') vals += ",";
                            vals += answer.split(",")[j];
                            that.$scope.answers2[curr.code][answer.split(",")[j]] = true;
                        } else {
                            exists = true;
                            delete that.$scope.answers2[curr.code][answer.split(",")[j]];
                            delete that.$scope.answers[curr.code + 'Memo'];
                        }
                    }
                    if (curr.maxLen && vals.split(",").length >= curr.maxLen) {
                        return false;
                    }
                    if (!exists) {
                        if (vals !== '') vals += ",";
                        vals += val;
                        that.$scope.answers2[curr.code][val] = true;
                    }
                    that.$scope.answers[curr.code] = vals;
                }
            }
        },
        choose2(index, name) {
            let val = index + '';
            that.$scope.answers[name] = val + "";
            that.$scope.answers2[name] = {};
            that.$scope.answers2[name][val] = true;
        },
        choose3(index, val1) {
            let val = val1 + "";
            let name = 'detailC6';
            that.$scope.answers[name + index] = val;
            that.$scope.answers2[name + index] = {};
            that.$scope.answers2[name + index][val] = true;

            let vals = "";
            for (let i = 1; i <= 6; i++) {
                if (that.$scope.answers[name + i]) {
                    if (vals !== '') vals += ",";
                    vals += that.$scope.answers[name + i];
                }
            }
            that.$scope.answers[name] = vals;
            console.warn(vals, 1);
        },
        change(index) {
            that.$scope.answers[that.$scope.curr.code + 'Memo'] = that.$scope.answers[that.$scope.curr.code + 'Memo' + index];
        },
        chooseUser(name, val) {
            that.$scope.user[name] = val;
        },
        clickText($event, val1) {
            let val = val1 + "";
            $event.stopPropagation();
            let curr = that.$scope.curr;
            let name = curr.code;
            if (curr.type === 'radio') {
                that.$scope.answers[name] = val;
                that.$scope.answers2[name] = {};
                that.$scope.answers2[name][val] = true;

                if (curr.memo && curr.memo.length > 0) {
                    if (curr.memo.length === 1 && curr.memo[0] != val) {
                        that.$scope.answers[curr.code + 'Memo'] = '';
                    } else {
                        for (let i = 0; i < curr.memo.length; i++) {
                            if (curr.memo[i] != val) {
                                that.$scope.answers[curr.code + 'Memo' + curr.memo[i]] = '';
                            }
                        }
                    }
                }
            } else {
                let answer = that.$scope.answers[curr.code];
                if (!answer) {
                    that.$scope.answers[curr.code] = val + '';
                    that.$scope.answers2[curr.code] = {};
                    that.$scope.answers2[curr.code][val] = true;
                } else {
                    let vals = "";
                    let exists = false;
                    for (let j = 0; j < answer.split(",").length; j++) {
                        if (curr.only && curr.only[0] == answer.split(",")[j]) {
                            delete that.$scope.answers2[curr.code][answer.split(",")[j]];
                        } else {
                            if (vals !== '') vals += ",";
                            vals += answer.split(",")[j];
                            that.$scope.answers2[curr.code][answer.split(",")[j]] = true;
                            if (answer.split(",")[j] === val)
                                exists = true;
                        }
                    }
                    if (!exists) {
                        if (vals !== '') vals += ",";
                        vals += val;
                        that.$scope.answers2[curr.code][val] = true;
                    }
                    that.$scope.answers[curr.code] = vals;
                }
            }
        },
        changeAge() {
            let d = new Date();
            let month = d.getMonth() > 9 ? (d.getMonth() + 1) : '0' + (d.getMonth() + 1);
            let date = d.getDate() > 9 ? d.getDate() : '0' + d.getDate();
            that.$scope.user.birthday = (d.getFullYear() - that.$scope.user.age) + '-' + month + "-" + date;
        }
    });
})();