(function() {
    me.define("comDynamic", {
        components: {
            "comNoData": "components/nodata/comNoData"
        },

        data: {},
        ctrl: function() {
            this.$scope.data = []
            this.$scope.pageIndex = 0 //初始页
            this.$scope.dolike = false
            this.$scope.isShow = false //评论列表出始是隐藏
        },

        ready: function() {
            this.listData();
        },

        //查询问答列表
        listData: function(callback) {
            var that = this;
            if (!that.$scope.data) that.$scope.data = []
            Util.ajax({
                data: {
                    pageSize: 10,
                    pageIndex: that.$scope.pageIndex,
                    userId: me.global.userInfo.id
                },
                url: Util.getApiUrl("/course/getList/ask")
            }, function(data) {
                // that.$scope.data = data;
                that.$scope.dataCount = data.count;
                data.list.map(item => {
                    that.$scope.data.push(item)
                })
                that.resourceLike(data.list);
                that.asfReply(data.list);
                callback && callback()

            });

        },
        onScroll: function(callback) {
            var that = this
            if (that.$scope.dataCount <= that.$scope.data.length) return
            that.$scope.pageIndex += 1;
            that.listData(callback);
        },
        // 点赞数据处理
        resourceLike: function(resourceList) {
            if (resourceList.length == 0) return;

            var resourceIds = resourceList.map(d => d.id).join(",");
            Util.ajax({
                data: {
                    resourceId: resourceIds,
                    userId: me.global.userInfo.id
                },
                url: Util.getApiUrl("/course/getList/resourceLike")
            }, function(data) {
                var likeMap = Util.toMap(data, "resourceId");
                resourceList.forEach(res => {
                    res.isLike = !!likeMap[res.id]; //加上!! 转化布尔值
                });
            });
        },
        //点赞与取消
        isLike: function(id) {
            var that = this
            Util.ajax({
                data: {
                    resourceId: id
                },
                url: Util.getApiUrl("/course/resource/like")
            }, function(data) {
                that.$scope.data.forEach(item => {
                    if (item.id == id) {
                        item.isLike = !item.isLike
                        if (item.isLike == true) { //点赞成功移除动画
                            that.$scope.dolike = true
                        }
                    }
                })
            });
        },
        //处理查询回答数据
        asfReply: function(dataList) {
            if (dataList.length == 0) return;
            var askId = dataList.map(d => d.id).join(",");
            Util.ajax({
                data: {
                    askId: askId
                },
                url: Util.getApiUrl("/course/getList/askReply")
            }, function(data) {
                dataList.forEach(res => {
                    data.map(item => {
                        if (res.id == item.askId) {
                            res.pinglun = data
                        }
                    })

                });
            });
        },
        showAll(item) {
            item.showAll = !item.showAll
        },
        update: function(data) {},
        //  setData:function(data){
        // this.$scope.dynamicList=data
        // }

        notice: function() {
            // me.triggerCom(this.id,"onNotice",{name:1},2,true,"4");

        }
    }, true);
})();