(function() {
    var that = me.define("resource", {
        components: {
            "comResourceVideo": "pages/resource/components/resourceVideo/comResourceVideo",
            "comCommonProblem": "pages/resource/components/commonProblem/comCommonProblem",
            "comDynamic": "pages/resource/components/dynamic/comDynamic",
            "comStorys": "pages/resource/components/storys/comStorys"
        },
        ctrl: function() {
            // Util.setAppTitle("戒烟资源库","center");

            //tab 首次进入页面tab 选项卡数据
            that.$scope.navTitles = [
                //1:文章 2.专家视频 3.故事 4.问答
                { resourceType: 2, resourceName: "专家视频" },
                { resourceType: 3, resourceName: "故事" },
                { resourceType: 1, resourceName: "常见问题" },
                { resourceType: 4, resourceName: "问答" }
            ]
            that.$scope.flag = 2 //默认进入该页面数据展示的是专家视频

            that.$scope.data = [] //tab 栏切换的时对映显示的数据


            // const token=me.global.userInfo      

            that.$scope.pageIndex = 0
            //组件名
            that.$scope.comMap = {
                2: "comResourceVideo",
                3: "comStorys",
                1: "comCommonProblem"
            };
            //页面初始数据
            that.listData()
        },
        listData: function(callback) {
            const requestData = {
                pageSize: 10,
                pageIndex: that.$scope.pageIndex,
                resourceType: that.$scope.flag
            };
            switch (that.$scope.flag) {
                case 2:
                    requestData.labels = "专家视频:";
                    break;
            }
            Util.ajax({
                data: requestData,
                url: Util.getApiUrl("/course/getList/resource")
            }, function(data) {
                that.$scope.dataCount = data.count;
                Util.merge(that.$scope.data, data.list);
                if (that.$scope.flag == 3) {
                    me.getCom("comStorys", com => {
                        com.setData(that.$scope.data);
                    });
                } else if (that.$scope.flag == 2) {
                    me.getCom("comResourceVideo", function(com) {
                        com.setData(that.$scope.data);
                    })
                } else if (that.$scope.flag == 1) {
                    me.getCom("comCommonProblem", function(com) {
                        com.setData(that.$scope.data);
                    })
                }
                //获取点赞数据
                that.resourceLike(data.list);

                callback && callback();
            });
        },
        onScroll: function(callback) {
            if (that.$scope.dataCount <= that.$scope.data.length) {
                callback();
                return;
            }
            that.$scope.pageIndex += 1;
            that.listData(callback);
        },

        chooseFlag(resourceType) {
            that.$scope.dataCount = 0;
            that.$scope.pageIndex = 0;
            that.$scope.data.length = 0;
            that.$scope.flag = resourceType;
            that.listData()
        },
        // 点赞数据处理
        resourceLike: function(resourceList) {
            if (resourceList.length == 0) return;

            var resourceIds = resourceList.map(d => d.id).join(",");
            Util.ajax({
                data: {
                    resourceId: resourceIds,
                    userId: me.global.userInfo.id
                },
                url: Util.getApiUrl("/course/getList/resourceLike")
            }, function(data) {
                var likeMap = Util.toMap(data, "resourceId");
                resourceList.forEach(res => {
                    res.isLike = !!likeMap[res.id];
                });
            });
        },

        //咨询专家
        show() {
            me.show("resource/consultantExpert/consultantExpert", {
                showType: 1,
                param: {}
            }).on("hide", function(data) {
                if (!data) return;
            });
        },

        // 发布故事
        publishStory() {
            Util.showPage("resource/publishStory/publishStory", "发布故事", {}, function(isSave) {
                if (!isSave) return;
                that.chooseFlag(that.$scope.flag);
            });
        },

        //立即提问
        askQquestions() {
            Util.showPage("resource/askQuestions/askQuestions", "发布提问", {}, function(isSave) {
                if (!isSave) return;
                me.getCom("resource-dynamic", function(com) {
                    com.listData();
                });
            });
        },

        toAsk: function() {
            index.switchMenu(3);
        },

    });
})();