(function () {
    var that = me.define("audioList", {
        // 组件可接收的属性参数，如<comDemo cid="myComDemo" value="1"></comDemo>
        data: {
            type: {
                type: Number
            },
            name: {
                type: String
            }
        },

        // 组件的初始化方法用ready，ctrl入口方法不可缺少
        ctrl: function () {
        },
        ready: function () {
            that.$scope.data = [];
            that.$scope.pageIndex = 0;
            that.$scope.dataCount = 0;
            that.initList();
        },
        initList: function (callback) {
            Util.ajax({
                data: {
                    resourceType: that.$scope.type,
                    labels: that.$scope.name + ':',
                    pageIndex: that.$scope.pageIndex,
                    pageSize: 10
                },
                url: Config.apiPre + "/course/getList/resource"
            }, function (data) {
                that.$scope.dataCount = data.count;
                Util.merge(that.$scope.data, data.list);

                callback && callback();
            });
        },

        scroll: function (callback) {
            if (that.$scope.dataCount <= that.$scope.data.length) {
                callback();
                return;
            }
            that.$scope.pageIndex += 1;
            that.initList(callback);
        },
    });
})();